/*!
* WP Grid Builder Plugin
*
* @package   WP Grid Builder
* @author    Loïc Blascos
* @link      https://www.wpgridbuilder.com
* @copyright 2019-2024 Loïc Blascos
*
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.DOMPurify=t()}(this,function(){"use strict";var ue=["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"],he=["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","audio","canvas","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","video","view","vkern"],me=["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","feSpecularLighting","feTile","feTurbulence"],ge=["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmuliscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mpspace","msqrt","mystyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"],fe=["#text"],be=["accept","action","align","alt","autocomplete","background","bgcolor","border","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","coords","crossorigin","datetime","default","dir","disabled","download","enctype","face","for","headers","height","hidden","high","href","hreflang","id","integrity","ismap","label","lang","list","loop","low","max","maxlength","media","method","min","multiple","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","type","usemap","valign","value","width","xmlns"],ye=["accent-height","accumulate","additivive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"],we=["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"],ve=["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"];function _e(e,t){for(var n=t.length;n--;)"string"==typeof t[n]&&(t[n]=t[n].toLowerCase()),e[t[n]]=!0;return e}function Se(e){var t={},n=void 0;for(n in e)Object.prototype.hasOwnProperty.call(e,n)&&(t[n]=e[n]);return t}var xe=/\{\{[\s\S]*|[\s\S]*\}\}/gm,ke=/<%[\s\S]*|[\s\S]*%>/gm,Ee=/^data-[\-\w.\u00B7-\uFFFF]/,Ce=/^aria-[\-\w]+$/,Te=/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i,Le=/^(?:\w+script|data):/i,Pe=/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205f\u3000]/g,Ne="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e};function Oe(e){if(Array.isArray(e)){for(var t=0,n=Array(e.length);t<e.length;t++)n[t]=e[t];return n}return Array.from(e)}return function q(e){var a=0<arguments.length&&void 0!==e?e:"undefined"==typeof window?null:window,c=function(e){return q(e)};if(c.version="1.0.3",c.removed=[],a&&a.document&&9===a.document.nodeType){var l=a.document,o=!1,r=!1,d=a.document,p=a.DocumentFragment,e=a.HTMLTemplateElement,u=a.Node,t=a.NodeFilter,n=a.NamedNodeMap,R=void 0===n?a.NamedNodeMap||a.MozNamedAttrMap:n,D=a.Text,F=a.Comment,B=a.DOMParser,j=void 0===(n=a.XMLHttpRequest)?a.XMLHttpRequest:n,H=void 0===(n=a.encodeURI)?a.encodeURI:n,e=d="function"==typeof e&&(n=d.createElement("template")).content&&n.content.ownerDocument?n.content.ownerDocument:d,s=e.implementation,W=e.createNodeIterator,G=e.getElementsByTagName,U=e.createDocumentFragment,Y=l.importNode,i={},h=(c.isSupported=s&&void 0!==s.createHTMLDocument&&9!==d.documentMode,xe),m=ke,V=Ee,X=Ce,$=Le,g=Pe,f=Te,b=null,y=_e({},[].concat(Oe(ue),Oe(he),Oe(me),Oe(ge),Oe(fe))),w=null,v=_e({},[].concat(Oe(be),Oe(ye),Oe(we),Oe(ve))),_=null,S=null,J=!0,x=!0,Z=!1,K=!1,k=!1,E=!1,C=!1,T=!1,L=!1,P=!1,Q=!1,ee=!0,N=!0,O={},te=_e({},["audio","head","math","script","style","template","svg","video"]),ne=_e({},["audio","video","img","source","image"]),ie=_e({},["alt","class","for","id","label","name","pattern","placeholder","summary","title","value","style","xmlns"]),A=null,oe=d.createElement("form"),re=function(e){"object"!==(void 0===e?"undefined":Ne(e))&&(e={}),b="ALLOWED_TAGS"in e?_e({},e.ALLOWED_TAGS):y,w="ALLOWED_ATTR"in e?_e({},e.ALLOWED_ATTR):v,_="FORBID_TAGS"in e?_e({},e.FORBID_TAGS):{},S="FORBID_ATTR"in e?_e({},e.FORBID_ATTR):{},O="USE_PROFILES"in e&&e.USE_PROFILES,J=!1!==e.ALLOW_ARIA_ATTR,x=!1!==e.ALLOW_DATA_ATTR,Z=e.ALLOW_UNKNOWN_PROTOCOLS||!1,K=e.SAFE_FOR_JQUERY||!1,k=e.SAFE_FOR_TEMPLATES||!1,E=e.WHOLE_DOCUMENT||!1,L=e.RETURN_DOM||!1,P=e.RETURN_DOM_FRAGMENT||!1,Q=e.RETURN_DOM_IMPORT||!1,T=e.FORCE_BODY||!1,ee=!1!==e.SANITIZE_DOM,N=!1!==e.KEEP_CONTENT,f=e.ALLOWED_URI_REGEXP||f,k&&(x=!1),P&&(L=!0),O&&(b=_e({},[].concat(Oe(fe))),w=[],!0===O.html&&(_e(b,ue),_e(w,be)),!0===O.svg&&(_e(b,he),_e(w,ye),_e(w,ve)),!0===O.svgFilters&&(_e(b,me),_e(w,ye),_e(w,ve)),!0===O.mathMl)&&(_e(b,ge),_e(w,we),_e(w,ve)),e.ADD_TAGS&&_e(b=b===y?Se(b):b,e.ADD_TAGS),e.ADD_ATTR&&_e(w=w===v?Se(w):w,e.ADD_ATTR),e.ADD_URI_SAFE_ATTR&&_e(ie,e.ADD_URI_SAFE_ATTR),N&&(b["#text"]=!0),Object&&"freeze"in Object&&Object.freeze(e),A=e},se=function(t){c.removed.push({element:t});try{t.parentNode.removeChild(t)}catch(e){t.outerHTML=""}},M=function(e,t){try{c.removed.push({attribute:t.getAttributeNode(e),from:t})}catch(e){c.removed.push({attribute:null,from:t})}t.removeAttribute(e)},z=function(e){var t=void 0,n=void 0;if(T&&(e="<remove></remove>"+e),r){try{e=H(e)}catch(e){}var i=new j;i.responseType="document",i.open("GET","data:text/html;charset=utf-8,"+e,!1),i.send(null),t=i.response}if(o)try{t=(new B).parseFromString(e,"text/html")}catch(e){}return t&&t.documentElement||((n=(t=s.createHTMLDocument("")).body).parentNode.removeChild(n.parentNode.firstElementChild),n.outerHTML=e),G.call(t,E?"html":"body")[0]};if(c.isSupported){(n=z('<svg><g onload="this.parentNode.remove()"></g></svg>')).querySelector("svg")||(r=!0);try{(n=z('<svg><p><style><img src="</style><img src=x onerror=alert(1)//">')).querySelector("svg img")&&(o=!0)}catch(e){}}var ae=function(e){return W.call(e.ownerDocument||e,e,t.SHOW_ELEMENT|t.SHOW_COMMENT|t.SHOW_TEXT,function(){return t.FILTER_ACCEPT},!1)},le=function(e){return"object"===(void 0===u?"undefined":Ne(u))?e instanceof u:e&&"object"===(void 0===e?"undefined":Ne(e))&&"number"==typeof e.nodeType&&"string"==typeof e.nodeName},I=function(e,t,n){i[e]&&i[e].forEach(function(e){e.call(c,t,n,A)})},ce=function(e){var t=void 0;if(I("beforeSanitizeElements",e,null),(n=e)instanceof D||n instanceof F||"string"==typeof n.nodeName&&"string"==typeof n.textContent&&"function"==typeof n.removeChild&&n.attributes instanceof R&&"function"==typeof n.removeAttribute&&"function"==typeof n.setAttribute){var n=e.nodeName.toLowerCase();if(I("uponSanitizeElement",e,{tagName:n,allowedTags:b}),b[n]&&!_[n])return!K||e.firstElementChild||e.content&&e.content.firstElementChild||!/</g.test(e.textContent)||(c.removed.push({element:e.cloneNode()}),e.innerHTML=e.textContent.replace(/</g,"&lt;")),k&&3===e.nodeType&&(t=(t=(t=e.textContent).replace(h," ")).replace(m," "),e.textContent!==t)&&(c.removed.push({element:e.cloneNode()}),e.textContent=t),I("afterSanitizeElements",e,null),!1;if(N&&!te[n]&&"function"==typeof e.insertAdjacentHTML)try{e.insertAdjacentHTML("AfterEnd",e.innerHTML)}catch(e){}}return se(e),!0},de=function(e){var t,n,i=void 0,o=void 0,r=void 0,s=void 0,a=void 0;if(I("beforeSanitizeAttributes",e,null),s=e.attributes){for(var l={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:w},a=s.length;a--;){if(o=(i=s[a]).name,r=i.value.trim(),t=o.toLowerCase(),l.attrName=t,l.attrValue=r,l.keepAttr=!0,I("uponSanitizeAttribute",e,l),r=l.attrValue,"name"===t&&"IMG"===e.nodeName&&s.id)n=s.id,s=Array.prototype.slice.apply(s),M("id",e),M(o,e),s.indexOf(n)>a&&e.setAttribute("id",n.value);else{if("INPUT"===e.nodeName&&"type"===t&&"file"===r&&(w[t]||!S[t]))continue;"id"===o&&e.setAttribute(o,""),M(o,e)}if(l.keepAttr&&(!ee||"id"!==t&&"name"!==t||!(r in d||r in oe))){if(k&&(r=(r=r.replace(h," ")).replace(m," ")),!(x&&V.test(t)||J&&X.test(t))){if(!w[t]||S[t])continue;if(!ie[t]&&!f.test(r.replace(g,""))&&("src"!==t&&"xlink:href"!==t||0!==r.indexOf("data:")||!ne[e.nodeName.toLowerCase()])&&(!Z||$.test(r.replace(g,"")))&&r)continue}try{e.setAttribute(o,r),c.removed.pop()}catch(e){}}}I("afterSanitizeAttributes",e,null)}},pe=function e(t){var n,i=ae(t);for(I("beforeSanitizeShadowDOM",t,null);n=i.nextNode();)I("uponSanitizeShadowNode",n,null),ce(n)||(n.content instanceof p&&e(n.content),de(n));I("afterSanitizeShadowDOM",t,null)};c.sanitize=function(e,t){var n,i=void 0,o=void 0,r=void 0;if("string"!=typeof(e=e||"\x3c!--\x3e")&&!le(e)){if("function"!=typeof e.toString)throw new TypeError("toString is not a function");if("string"!=typeof(e=e.toString()))throw new TypeError("dirty is not a string, aborting")}if(!c.isSupported){if("object"===Ne(a.toStaticHTML)||"function"==typeof a.toStaticHTML){if("string"==typeof e)return a.toStaticHTML(e);if(le(e))return a.toStaticHTML(e.outerHTML)}return e}if(C||re(t),c.removed=[],e instanceof u)1===(t=(i=z("\x3c!--\x3e")).ownerDocument.importNode(e,!0)).nodeType&&"BODY"===t.nodeName?i=t:i.appendChild(t);else{if(!L&&!E&&-1===e.indexOf("<"))return e;if(!(i=z(e)))return L?null:""}T&&se(i.firstChild);for(var s=ae(i);n=s.nextNode();)3===n.nodeType&&n===o||ce(n)||(n.content instanceof p&&pe(n.content),de(n),o=n);if(L){if(P)for(r=U.call(i.ownerDocument);i.firstChild;)r.appendChild(i.firstChild);else r=i;return r=Q?Y.call(l,r,!0):r}return E?i.outerHTML:i.innerHTML},c.setConfig=function(e){re(e),C=!0},c.clearConfig=function(){A=null,C=!1},c.addHook=function(e,t){"function"==typeof t&&(i[e]=i[e]||[],i[e].push(t))},c.removeHook=function(e){i[e]&&i[e].pop()},c.removeHooks=function(e){i[e]&&(i[e]=[])},c.removeAllHooks=function(){i={}}}else c.isSupported=!1;return c}()}),function(){!function(){"use strict";function e(e,t){t=t||{bubbles:!1,cancelable:!1,detail:void 0};var n=document.createEvent("CustomEvent");return n.initCustomEvent(e,t.bubbles,t.cancelable,t.detail),n}"function"!=typeof window.CustomEvent&&(e.prototype=window.Event.prototype,window.CustomEvent=e)}(),A=window,o=0,A.requestAnimationFrame=A.requestAnimationFrame||A.webkitRequestAnimationFrame,A.requestAnimationFrame||(A.requestAnimationFrame=function(e){var t=(new Date).getTime(),n=Math.max(0,16-(t-o)),e=setTimeout(e,n);return o=t+n,e}),A.cancelAnimationFrame||(A.cancelAnimationFrame=function(e){clearTimeout(e)});var o,p={},t=window.console,F=function(){var e=window.Element.prototype;if(e.matches)return"matches";if(e.matchesSelector)return"matchesSelector";for(var t=["webkit","moz","ms","o"],n=0;n<t.length;n++){var i=t[n]+"MatchesSelector";if(e[i])return i}}();function B(e){return function(e){if(Array.isArray(e)){for(var t=0,n=new Array(e.length);t<e.length;t++)n[t]=e[t];return n}}(e)||function(e){if(Symbol.iterator in Object(e)||"[object Arguments]"===Object.prototype.toString.call(e))return Array.from(e)}(e)||function(){throw new TypeError("Invalid attempt to spread non-iterable instance")}()}function r(e){return(r="function"==typeof Symbol&&"symbol"==typeof Symbol.iterator?function(e){return typeof e}:function(e){return e&&"function"==typeof Symbol&&e.constructor===Symbol&&e!==Symbol.prototype?"symbol":typeof e})(e)}function j(e,t){if(e=e,!(null!=(t=t)&&"undefined"!=typeof Symbol&&t[Symbol.hasInstance]?t[Symbol.hasInstance](e):e instanceof t))throw new TypeError("Cannot call a class as a function")}function H(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}p.error=function(e){void 0!==t&&t.error(e)},p.docReady=function(e){var t=document.readyState;"complete"===t||"interactive"===t?setTimeout(e):document.addEventListener("DOMContentLoaded",e)},p.isIE=function(){var e=window.navigator.userAgent,t=e.indexOf("MSIE "),n=e.indexOf("Trident/");return 0<t?parseInt(e.substring(t+5,e.indexOf(".",t)),10):0<n&&(t=e.indexOf("rv:"),parseInt(e.substring(t+3,e.indexOf(".",t)),10))},p.matchesSelector=function(e,t){return e[F](t)},p.getParent=function(e,t){for(;e&&e!=document.body;){if(e.classList&&p.matchesSelector(e,t))return e;e=e.parentNode}},p.extend=function(e,t){if("object"!=typeof e)this.error("Args to extend must be an object");else for(var n in t)t.hasOwnProperty(n)&&!e.hasOwnProperty(n)&&(e[n]=t[n]);return e},p.merge=function(e,t){var n,i={};for(n in e)e.hasOwnProperty(n)&&(i[n]=e[n]);for(n in t)t.hasOwnProperty(n)&&(i[n]=t[n]);return i},p.modulo=function(e,t){return(e+t%e)%e},p.clone=function(e){if("[object Array]"===Object.prototype.toString.call(e))for(var t=[],n=0,i=e.length;n<i;n++)t[n]=p.clone(e[n]);else{if("object"!=typeof e)return e;for(var o in t={},e)e.hasOwnProperty(o)&&(t[o]=p.clone(e[o]))}return t},p.removeChildren=function(e){if(e)for(;e.firstChild;)e.removeChild(e.firstChild)},p.detectPointers=function(){return navigator.pointerEnabled?{down:["pointerdown"],move:["pointermove"],up:["pointerup","pointercancel"]}:navigator.msPointerEnabled?{down:["MSPointerDown"],move:["MSPointerMove"],up:["MSPointerUp","MSPointerCancel"]}:{down:["mousedown","touchstart"],move:["mousemove","touchmove"],up:["mouseup","mouseleave","touchend","touchcancel"]}},p.Transitionend=function(){var e,t=document.createElement("div"),n={transition:"transitionend",OTransition:"oTransitionEnd",MozTransition:"transitionend",WebkitTransition:"webkitTransitionEnd"};for(e in n)if(n.hasOwnProperty(e)&&void 0!==t.style[e])return t=null,n[e]},p.handleEvent=function(t,n,e,i,o){t.eventListeners||(t.eventListeners={}),t.eventListeners[i]||(t.eventListeners[i]=t[i].bind(t)),o=(o=void 0===o||!!o)?"addEventListener":"removeEventListener",e.forEach(function(e){n[o](e,t.eventListeners[i],"touchstart"===e&&{passive:!1})})},p.dispatchEvent=function(e,t,n){t=new CustomEvent(t,{detail:n});e.dispatchEvent(t)},p.dispatchHTMLEvent=function(e,t){var n;document.createEvent?((n=document.createEvent("HTMLEvents")).initEvent(t,!0,!0),e.dispatchEvent(n)):((n=document.createEventObject()).eventType=t,e.fireEvent("on"+n.eventType,n))},p.throttle=function(n,i){function o(){c=Date.now(),l=null,a=n.apply(r,s),l||(r=s=null)}var r,s,a,l=null,c=0;return function(){var e=Date.now(),t=i-(e-c);return r=this,s=arguments,t<=0||i<t?(l&&(clearTimeout(l),l=null),c=e,a=n.apply(r,s),l||(r=s=null)):l=l||setTimeout(o,t),a}};function W(){}function s(e,t){for(e=String(e);e.length<t;)e="0"+e;return e}function e(){}function n(e,t){this.canvas=document.querySelector(e),this.layout=t||"horizontal",this.marker=this.canvas.nextElementSibling,this.ruler=document.querySelector(".wpgb-builder-right-panel"),this.bindEvents(),this.getBound(),this.draw()}function h(){this.icons=document.querySelectorAll(".wpgb-icons-popup-wrapper span"),this.length=this.icons.length,document.querySelector(".wpgb-icons-popup input").addEventListener("input",this),document.querySelector(".wpgb-icons-popup").addEventListener("click",this),document.addEventListener("click",this.open.bind(this)),window.addEventListener("resize",this.open.bind(this))}function G(e,i){function o(e){t=requestAnimationFrame(e)}function r(){t&&(cancelAnimationFrame(t),t=null)}function s(){var e,t=c-l,n=Date.now()-a;if(d.scrollTop=(e=n,-t*(e/=i)*(e-2)+l),i<=n)return d.scrollTop=c,r();o(s)}i=i||300;var t,a,l,c,d=function(e){for(var t=e.parentElement;t;){var n=getComputedStyle(t,null),i=n.getPropertyValue("overflow");if(i+=n.getPropertyValue("overflow-y"),/(auto|scroll)/.test(i))return t;t=t.parentElement}}(e);d&&(a=Date.now(),l=d.scrollTop,(c=e.offsetTop)!==l)&&(r(),o(s))}function d(e){e.wpgb_resizable||(this.element=e,this.element.wpgb_resizable=1,this.pointers=p.detectPointers(),this.transitionend=p.Transitionend(),this.create(),p.handleEvent(this,this.element,this.pointers.down,"pointerDown"))}function a(e){this.pointers=p.detectPointers(),this.transitionend=p.Transitionend(),this.options=e?p.extend(e,Y):Y,this.computed={},this.snapTo=this.options.snapTo?document.querySelector(this.options.snapTo):null,p.handleEvent(this,document,this.pointers.down,"pointerDown"),document.querySelector('[name="wpgb-snap-to-grid"]').addEventListener("click",this.snapToGrid.bind(this),!0)}function c(){this.pointers=p.detectPointers(),p.handleEvent(this,document,this.pointers.down,"pointerDown")}function u(){Object.keys(L).forEach(function(e){V["'"+e+"'"]=e})}function m(){if(E)return E;X.forEach(function(e){var t=document.createElement("style");document.head.appendChild(t),this[e+"Sheet"]=t.sheet}.bind(this)),E=this}function g(){}function f(){f.prototype.fonts=[],f.prototype.styleSheet=new m,document.addEventListener("change",this.getFontWeights.bind(this)),document.addEventListener("mouseover",this.getGoogleFont.bind(this))}function b(){T=P.L10n.blocks}function y(){g.call(this),this.view=new e,this.framework=new u,this.appendGeneralPanel(),this.bindEvents()}function w(){this.view=new e,window.addEventListener("click",this.openList.bind(this),!0),window.addEventListener("wpgb_builder.sort_start",this.openList.bind(this)),window.addEventListener("wpgb_builder.resize_start",this.openList.bind(this))}function v(){y.call(this),this.styleSheet=new m,document.addEventListener("click",this.blockActions.bind(this),!1),document.addEventListener("click",this.selectBlock.bind(this),!1),document.addEventListener("click",this.addBlock.bind(this),!1)}function _(){this.view=new e,this.styleSheet=new m,window.addEventListener("scroll",this.hide.bind(this),!1),window.addEventListener("resize",this.hide.bind(this),!1),document.addEventListener("click",this.hide.bind(this),!1),document.addEventListener("contextmenu",this.reveal.bind(this),!1),window.addEventListener("wpgb_builder.sort_start",this.hide.bind(this))}var S,U,k,E,C,T,L,P,N,O,A=function(){function e(){j(this,e),this.listeners=new Map}var t,n,i;return t=e,(n=[{key:"canListen",value:function(e,t){return!("function"!=typeof t||!e)||!("object"!==r(t)||!t[e])||(console.error('Invalid listener for event name: "'.concat(e,'"')),!1)}},{key:"exists",value:function(e,t){if(this.listeners.has(e))return this.listeners.get(e).find(function(e){return e.listener===t})}},{key:"on",value:function(e,t){var n=2<arguments.length&&void 0!==arguments[2]&&arguments[2];return this.canListen(e,t)&&(this.listeners.has(e)||this.listeners.set(e,[]),this.exists(e,t)||this.listeners.get(e).push({listener:t,once:n})),this}},{key:"once",value:function(e,t){return this.on(e,t,!0)}},{key:"off",value:function(e,t){var n=this.listeners.get(e)||[],i=n.findIndex(function(e){return e.listener===t});return-1<i&&n.splice(i,1),n.length<1&&this.listeners.delete(e),this}},{key:"offAll",value:function(){return this.listeners.clear(),this}},{key:"emit",value:function(n){for(var i=this,e=arguments.length,o=new Array(1<e?e-1:0),t=1;t<e;t++)o[t-1]=arguments[t];return B(this.listeners.get(n)||[]).forEach(function(e){var t;e.once&&i.off(n,e.listener),"object"===r(e.listener)?(t=e.listener[n]).apply.apply(t,[e.listener].concat(o)):(t=e.listener).apply.apply(t,[i].concat(o))}),this}}])&&H(t.prototype,n),i&&H(t,i),e}(),M=/\\?(.?)/gi,z=(W.prototype.getFormat=function(e){return S=new Date,e.replace(M,z)},function(e,t){return I[e]?I[e]():t}),I={d:function(){return s(I.j(),2)},D:function(){return wpgb_date_L10n.dayNamesShort[I.w()]},j:function(){return S.getDate()},l:function(){return wpgb_date_L10n.dayNames[I.w()]},N:function(){return I.w()||7},S:function(){var e=I.j(),t=e%10;return["st","nd","rd"][(t=t<=3&&1===parseInt(e%100/10,10)?0:t)-1]||"th"},w:function(){return S.getDay()},z:function(){var e=new Date(I.Y(),I.n()-1,I.j()),t=new Date(I.Y(),0,1);return Math.round((e-t)/864e5)},W:function(){var e=new Date(I.Y(),I.n()-1,I.j()-I.N()+3),t=new Date(e.getFullYear(),0,4);return s(1+Math.round((e-t)/864e5/7),2)},F:function(){return wpgb_date_L10n.monthNames[I.n()-1]},m:function(){return s(I.n(),2)},M:function(){return wpgb_date_L10n.monthNamesShort[I.n()-1]},n:function(){return S.getMonth()+1},t:function(){return new Date(I.Y(),I.n(),0).getDate()},L:function(){var e=I.Y();return e%4==0&e%100!=0|e%400==0},o:function(){var e=I.n(),t=I.W();return I.Y()+(12===e&&t<9?1:1===e&&9<t?-1:0)},Y:function(){return S.getFullYear()},y:function(){return I.Y().toString().slice(-2)},a:function(){return 11<S.getHours()?"pm":"am"},A:function(){return I.a().toUpperCase()},B:function(){var e=3600*S.getUTCHours(),t=60*S.getUTCMinutes(),n=S.getUTCSeconds();return s(Math.floor((e+t+n+3600)/86.4)%1e3,3)},g:function(){return I.G()%12||12},G:function(){return S.getHours()},h:function(){return s(I.g(),2)},H:function(){return s(I.G(),2)},i:function(){return s(S.getMinutes(),2)},s:function(){return s(S.getSeconds(),2)},u:function(){return s(1e3*S.getMilliseconds(),6)},v:function(){return s(S.getMilliseconds(),3)},e:function(){return wpgb_date_L10n.timezone},I:function(){return new Date(I.Y(),0)-Date.UTC(I.Y(),0)!=new Date(I.Y(),6)-Date.UTC(I.Y(),6)?1:0},O:function(){var e=S.getTimezoneOffset(),t=Math.abs(e);return(0<e?"-":"+")+s(100*Math.floor(t/60)+t%60,4)},P:function(){var e=I.O();return e.substr(0,3)+":"+e.substr(3,2)},T:function(){return wpgb_date_L10n.timezone_abbr},Z:function(){return 60*-S.getTimezoneOffset()},c:function(){return"Y-m-d\\TH:i:sP".replace(M,z)},r:function(){return"D, d M Y H:i:s O".replace(M,z)},U:function(){return S/1e3|0}},Y=(e.prototype.render=function(e){var n;return e.forEach(function(e,t){null!==e&&(t||"string"!=typeof e?t&&"string"==typeof e?n.firstChild?(t=document.createTextNode(e),n.appendChild(t)):n.textContent=e:n&&Array.isArray(e)?(t=this.render(e))&&n.appendChild(t):n&&"object"==typeof e&&this.renderAtts(n,e):n=-1<["svg","use"].indexOf(e)?document.createElementNS("http://www.w3.org/2000/svg",e):document.createElement(e))}.bind(this)),n},e.prototype.renderAtts=function(p,u){Object.keys(u).forEach(function(e){var t=u[e],n=e in p,i="readonly"===e,o="for"===e,r="type"===e,s="class"===e,a="xlink:href"===e,l="role"===e||-1<e.indexOf("data-"),c=-1<e.indexOf("aria-"),d="tabindex"===e;n||i||o||r||s||l||c||a||d?"style"===e?this.renderStyles(p,t):s?p.className=t:i||o||r||l||c||d?"data-wpgb"===e?p.wpgb=t:p.setAttribute(e,t):n?p[e]=t:a&&p.setAttributeNS("http://www.w3.org/1999/xlink",e,t):console.warn(e+" is not a valid property")}.bind(this))},e.prototype.renderStyles=function(t,n){n&&Object.keys(n).forEach(function(e){e in t.style?t.style[e]=n[e]:console.warn(e+" is not a valid style for a <"+t.tagName.toLowerCase()+">")})},n.prototype.bindEvents=function(){this.ruler.addEventListener("mouseenter",this.getBound.bind(this)),this.ruler.addEventListener("mousemove",this.move.bind(this)),window.addEventListener("scroll",this.getBound.bind(this),!1),window.addEventListener("resize",this.getBound.bind(this))},n.prototype.getBound=function(){this.bound=this.canvas.parentElement.getBoundingClientRect()},n.prototype.move=function(e){this.position={x:e.clientX,y:e.clientY},"horizontal"===this.layout?(e=2*Math.round((this.position.x-this.bound.left)/2),this.marker.style.transform="translate("+e+"px, 0)",this.marker.setAttribute("data-position",e)):(e=2*Math.round((this.position.y-this.bound.top)/2),this.marker.style.transform="translate(0,"+e+"px)",this.marker.setAttribute("data-position",e))},n.prototype.draw=function(){this.ctx=this.canvas.getContext("2d"),this.size={width:this.canvas.width,height:this.canvas.height},this.set_HDPI(),this.draw_ruler(),this.draw_origin(),this.marker.setAttribute("data-position",0)},n.prototype.set_HDPI=function(){var e,t,n=window.devicePixelRatio||1,i=this.ctx.webkitBackingStorePixelRatio||this.ctx.mozBackingStorePixelRatio||this.ctx.msBackingStorePixelRatio||this.ctx.oBackingStorePixelRatio||this.ctx.backingStorePixelRatio||1;n!==i&&(e=this.canvas.width,t=this.canvas.height,this.canvas.width=e*(n=n/i),this.canvas.height=t*n,this.canvas.style.width=e+"px",this.canvas.style.height=t+"px",this.ctx.scale(n,n))},n.prototype.draw_ruler=function(){this.draw_line(0,100,20,"#96a4b4"),this.draw_line(0,20,12,"rgba(147, 154, 170, 1)"),this.draw_line(10,20,8,"rgba(147, 154, 170, 0.7)")},n.prototype.draw_origin=function(){this.ctx.beginPath(),"horizontal"===this.layout?(this.ctx.moveTo(2500,0),this.ctx.lineTo(2500,50)):(this.ctx.moveTo(0,2500),this.ctx.lineTo(50,2500)),this.ctx.strokeStyle="#f85464",this.ctx.stroke()},n.prototype.draw_line=function(e,t,n,i){var o=Math.round(this.size["horizontal"===this.layout?"width":"height"]/t);this.ctx.beginPath();for(var r=0;r<o;r++)20===t&&0===e&&r%5==0||100===t&&25===r||("horizontal"===this.layout?(this.ctx.moveTo(e+r*t,50),this.ctx.lineTo(e+r*t,50-n)):(this.ctx.moveTo(50-n,e+r*t),this.ctx.lineTo(50,e+r*t)));this.ctx.strokeStyle=i,this.ctx.stroke()},h.prototype.handleEvent=function(e){e.preventDefault(),e.stopPropagation();var t="on"+e.type;this[t]&&this[t](e)},h.prototype.open=function(e){var e=p.getParent(e.target,".wpgb-icon-picker"),t=document.querySelector(".wpgb-icons-popup");if(e){this.picker=e,this.input=e.lastElementChild;var n=document.querySelector(".wpgb-icons-popup .wpgb-icon-selected"),i=e.parentElement.getBoundingClientRect(),o=window.innerWidth;n&&n.classList.remove("wpgb-icon-selected"),o<=1280?(n=t.parentElement.getBoundingClientRect(),t.style.top=i.top-n.top+"px",t.style.left=i.left-n.left+"px",t.style.position="absolute"):(t.style.top=i.top+"px",t.style.left=i.left+"px",t.style.position=""),t.style.width=e.parentElement.clientWidth+"px",(r=this.getScrollParent(this.picker))&&r.classList.add("wpgb-disable-scroll"),t.classList.toggle("wpgb-show"),e.classList.toggle("wpgb-open"),t.firstElementChild.focus(),this.selectIcon()}else{for(var r,s=document.querySelectorAll(".wpgb-icon-picker.wpgb-open"),a=0,l=s.length;a<l;a++)(r=this.getScrollParent(this.picker))&&r.classList.remove("wpgb-disable-scroll"),s[a].classList.remove("wpgb-open");t.classList.remove("wpgb-show")}},h.prototype.getScrollParent=function(e){for(var t=e.parentElement;t!==document.body;){var n=getComputedStyle(t,null),i=n.getPropertyValue("overflow");if(i+=n.getPropertyValue("overflow-y"),/(auto|scroll)/.test(i))return t;t=t.parentElement}},h.prototype.oninput=function(e){for(var t=e.target.value,n=0;n<this.length;n++){var i=this.icons[n],o=i.getAttribute("data-icon")||"";i.style.display=-1<o.indexOf(t)?"":"none"}},h.prototype.onclick=function(e){var t,n,i,e=p.getParent(e.target,".wpgb-icon-item");e&&(n=(t=this.picker.firstElementChild).firstElementChild,i=e.getAttribute("data-icon"),n&&t.removeChild(n),t.appendChild(e.firstElementChild.cloneNode(!0)),document.querySelector(".wpgb-icons-popup").classList.remove("wpgb-show"),this.picker.classList.remove("wpgb-open"),this.input.value=i,p.dispatchHTMLEvent(this.input,"change"))},h.prototype.selectIcon=function(){var e=document.querySelector('.wpgb-icons-popup [data-icon="'+this.input.value+'"]');e&&(e.parentNode.parentNode.scrollTop=0,e.parentNode.parentNode.scrollTop=e.getBoundingClientRect().top-e.parentNode.getBoundingClientRect().top,e.classList.add("wpgb-icon-selected"))},d.prototype.create=function(){this.resizer=document.createElement("div");var n=document.createDocumentFragment();["n","s","e","w","ne","se","sw","nw"].forEach(function(e){var t=document.createElement("div");t.className="wpgb-resize",t.setAttribute("data-resize",e),n.appendChild(t)}.bind(this)),this.resizer.className="wpgb-resizer",this.resizer.appendChild(n),this.element.appendChild(this.resizer)},d.prototype.mapPoint=function(e){e=e.touches?e.changedTouches:[e];return e[0]||{}},d.prototype.pointerDown=function(e){var t;this.resizing||(t=this.mapPoint(e),this.pointer={x:Math.round(t.pageX),y:Math.round(t.pageY)},this.sizer={height:this.element.clientHeight,width:this.element.clientWidth,direction:e.target.getAttribute("data-resize")},this.sizer.direction&&(p.handleEvent(this,window,this.pointers.move,"pointerMove"),p.handleEvent(this,window,this.pointers.up,"pointerUp")))},d.prototype.pointerMove=function(e){e.preventDefault(),e.stopPropagation();var t,n,e=this.mapPoint(e);this.delta={x:Math.round(e.pageX)-this.pointer.x,y:Math.round(e.pageY)-this.pointer.y},!this.resizing&&Math.abs(this.delta.x)<3&&Math.abs(this.delta.y)<3||(this.resizing?(document.body.classList.add("wpgb-resizing"),this.element.classList.add("wpgb-resized"),t={element:this.element,height:"",width:""},-1<["n","s","ne","se","sw","nw"].indexOf(this.sizer.direction)&&(n=-1<["n","ne","nw"].indexOf(this.sizer.direction)?-1:1,t.height=Math.max(4,this.sizer.height+this.delta.y*n),this.element.style.height=t.height+"px"),-1<["e","w","ne","se","sw","nw"].indexOf(this.sizer.direction)&&(n=-1<["w","sw","nw"].indexOf(this.sizer.direction)?-1:1,t.width=Math.max(4,this.sizer.width+this.delta.x*n),this.element.style.width=t.width+"px"),this.element.style.pointerEvents="none",p.dispatchEvent(window,"wpgb_builder.resize_move",t)):(this.resizing=!0,this.pointer.x+=this.delta.x,this.pointer.y+=this.delta.y,p.dispatchEvent(window,"wpgb_builder.resize_start",t)))},d.prototype.pointerUp=function(e){p.handleEvent(this,window,this.pointers.move,"pointerMove",!1),p.handleEvent(this,window,this.pointers.up,"pointerUp",!1),this.resizing&&p.dispatchEvent(window,"wpgb_builder.resize_end",{element:this.element}),document.body.classList.remove("wpgb-resizing"),this.element.classList.remove("wpgb-resized"),this.resizing=this.delta=!1},{handle:".wpgb-block",drop:".wpgb-droppable",cancel:".wpgb-resize",snapTo:".wpgb-card",classes:{dragged:"wpgb-dragged",placeholder:"wpgb-placeholder"}}),V=(a.prototype.mapPoint=function(e){e=e.touches?e.changedTouches:[e];return e[0]||{}},a.prototype.pointerDown=function(e){3===e.which||this.sorting||p.getParent(e.target,this.options.cancel)||document.querySelector(".wpgb-preview")||(this.draggable=p.getParent(e.target,this.options.handle),this.droppable=p.getParent(e.target,this.options.drop),this.draggable&&(e=this.mapPoint(e),this.pointer={x:Math.round(e.clientX),y:Math.round(e.clientY)},p.handleEvent(this,window,this.pointers.move,"pointerMove"),p.handleEvent(this,window,this.pointers.up,"pointerUp")))},a.prototype.pointerMove=function(e){var t=this.mapPoint(e),n=p.getParent(e.target,this.options.drop);this.droppable=n||this.droppable,this.delta={x:Math.round(t.clientX)-this.pointer.x,y:Math.round(t.clientY)-this.pointer.y},this.sorting?(e.preventDefault(),e.stopPropagation(),this.moveDraggedItem(),this.sortItems(t)):(5<Math.abs(this.delta.x)||5<Math.abs(this.delta.y))&&(this.pointer.x+=this.delta.x,this.pointer.y+=this.delta.y,this.sorting=!0,this.addDraggedItem(),this.pointerMove(e),document.body.classList.add("wpgb-dragging"),p.dispatchEvent(window,"wpgb_builder.sort_start",{element:this.draggable,droppable:this.droppable}))},a.prototype.pointerUp=function(e){p.handleEvent(this,window,this.pointers.move,"pointerMove",!1),p.handleEvent(this,window,this.pointers.up,"pointerUp",!1),this.sorting&&(O=!0,p.dispatchEvent(window,"wpgb_builder.sort_end",{element:this.draggable,droppable:this.droppable})),"absolute"!==this.computed.position&&this.draggedItem&&(this.delta.x||this.delta.y)?(O=!0,this.revertItem()):this.revertEnd()},a.prototype.revertItem=function(){var e=this.draggable.getBoundingClientRect(),t=this.getScrollOffset();p.handleEvent(this,this.draggedItem,[this.transitionend],"revertEnd"),this.draggable.classList.remove(this.options.classes.placeholder),this.draggedItem.style.transition="transform 0.3s",this.draggedItem.style.transform="translate3d("+(t.left+e.left)+"px,"+(t.top+e.top)+"px,0)",this.draggable.classList.add(this.options.classes.placeholder)},a.prototype.revertEnd=function(){document.body.classList.remove("wpgb-dragging"),this.draggable.classList.remove(this.options.classes.placeholder),this.removeDraggedItem(),this.sorting=!1},a.prototype.addDraggedItem=function(){this.initial=this.draggable.getBoundingClientRect(),this.computed=this.getComputedStyle(this.draggable),this.draggedItem=this.draggable.cloneNode(!0),this.draggedItem.style.width=this.initial.width+"px",this.draggedItem.style.height=this.initial.height+"px",this.draggedItem.style.padding=this.computed.padding,this.draggedItem.style.fontSize=this.computed.fontSize,this.draggedItem.style.lineHeight=this.computed.lineHeight,this.draggedItem.style.color=this.computed.color,this.draggedItem.classList.add(this.options.classes.dragged),this.draggable.classList.add(this.options.classes.placeholder),document.body.appendChild(this.draggedItem)},a.prototype.removeDraggedItem=function(){this.draggedItem&&(p.handleEvent(this,this.draggedItem,[this.transitionend],"revertEnd",!1),this.draggedItem=this.draggedItem.parentNode.removeChild(this.draggedItem),this.draggedItem=null)},a.prototype.moveDraggedItem=function(){var e,t,n=this.options.grid,i=this.getScrollOffset(),o=(this.snapTo||this.droppable.parentElement).getBoundingClientRect(),r={x:this.initial.left+this.delta.x,y:this.initial.top+this.delta.y};n&&"absolute"===this.computed.position&&(e=n&&n[0],n=n&&n[1],t=e?(o.left/e-Math.round(o.left/e))*e:0,o=n?(o.top/n-Math.round(o.top/n))*n:0,r.x=e?t+Math.round(r.x/e)*e:r.x,r.y=n?o+Math.round(r.y/n)*n:r.y),r.x+=i.left,r.y+=i.top,this.draggedItem.style.transform="translate3d("+r.x+"px,"+r.y+"px,0)",this.moveDraggable(i,r)},a.prototype.moveDraggable=function(e,t){var n,i,o;"absolute"===this.computed.position&&(n=this.droppable.parentElement.getBoundingClientRect(),i=window.getComputedStyle(this.droppable.parentElement),o=window.getComputedStyle(this.draggable),t.x=t.x-(n.left+e.left+parseInt(o.marginLeft,10)+parseInt(i.borderLeftWidth,10)),t.y=t.y-(n.top+e.top+parseInt(o.marginTop,10)+parseInt(i.borderTopWidth,10)),t.element=this.draggable,this.draggable.style.left=t.x+"px",this.draggable.style.top=t.y+"px",p.dispatchEvent(window,"wpgb_builder.sort_move",t))},a.prototype.sortItems=function(e){var t=this.droppable.children,n=this.getScrollOffset(),i=!1,o={},r=n.left+Math.round(e.clientX),s=n.top+Math.round(e.clientY);if(t.length){if("absolute"!==this.computed.position)for(var a=0,l=t.length;a<l;a++)if(t[a]===this.draggable)i=!0;else{var c,d,o=this.getComputedStyle(t[a]);if("absolute"!==o.position)if(o.left<r&&o.right>r&&o.top<s&&o.bottom>s)return c=s<o.top+(o.bottom-o.top)/2,d=(c="inline-block"===o.display&&"inline-block"===this.computed.display?r<o.left+(o.right-o.left)/2:c)?t[a]:t[a].nextSibling,(c?t[a].previousSibling:t[a].nextSibling)===this.draggable?void 0:void this.droppable.insertBefore(this.draggable,d)}else if(!this.droppable.contains(this.draggable))return void this.droppable.appendChild(this.draggable);!i&&s<o.bottom?this.droppable.insertBefore(this.draggable,this.droppable.firstElementChild):!i&&s>o.bottom&&this.droppable.appendChild(this.draggable)}else this.droppable.appendChild(this.draggable)},a.prototype.getScrollOffset=function(){return{left:window.pageXOffset,top:window.pageYOffset}},a.prototype.getComputedStyle=function(e){var t=e.getBoundingClientRect(),n=window.getComputedStyle(e),i=this.getScrollOffset(),o=parseInt(n.marginLeft,10)+parseInt(n.marginRight,10),r=parseInt(n.marginTop,10)+parseInt(n.marginBottom,10),s=parseInt(n.borderLeftWidth,10)+parseInt(n.borderRightWidth,10),a=parseInt(n.borderTopWidth,10)+parseInt(n.borderBottomWidth,10),l=parseInt(n.marginLeft,10)+parseInt(n.borderLeftWidth,10),c=parseInt(n.marginTop,10)+parseInt(n.borderTopWidth,10),o=t.right-t.left+o+s,s=t.bottom-t.top+r+a;return"block"===n.display&&(o=e.parentElement.clientWidth),{position:n.getPropertyValue("position"),display:n.getPropertyValue("display"),top:i.top+t.top-c,right:i.left+t.left-l+o,bottom:i.top+t.top-c+s,left:i.left+t.left-l,fontSize:n.getPropertyValue("font-size"),lineHeight:n.getPropertyValue("line-height"),padding:n.getPropertyValue("padding"),color:n.getPropertyValue("color")}},a.prototype.snapToGrid=function(e){e=e.target.checked;document.querySelector(".wpgb-builder-grid").style.display=e?"block":"none",this.options.grid=e?[10,10]:""},c.prototype.mapPoint=function(e){e=e.touches?e.changedTouches:[e];return e[0]||{}},c.prototype.pointerDown=function(e){var t,n=(n=p.getParent(e.target,".wpgb-handle-resize"))||p.getParent(e.target,".wpgb-panel-title");n&&!p.getParent(e.target,".wpgb-panel-close")&&(this.element=n.parentNode,this.method=n.classList.contains("wpgb-handle-resize")?"resize":"drag",n=this.element.getBoundingClientRect(),t=window.getComputedStyle(this.element),this.size={top:n.top+window.pageYOffset,left:n.left+window.pageXOffset,height:parseInt(t.getPropertyValue("height"),10),width:parseInt(t.getPropertyValue("width"),10),window:{width:window.innerWidth,height:window.innerHeight}},document.body.classList.add("wpgb-dragging"),p.handleEvent(this,window,this.pointers.move,"pointerMove"),p.handleEvent(this,window,this.pointers.up,"pointerUp"),n=this.mapPoint(e),this.pointer={x:Math.round(n.clientX),y:Math.round(n.clientY)},document.body.click())},c.prototype.pointerMove=function(e){e.preventDefault(),e.stopPropagation();var t,e=this.mapPoint(e);this.delta={x:Math.round(e.clientX)-this.pointer.x,y:Math.round(e.clientY)-this.pointer.y},"resize"===this.method?(this.element.style.height=this.size.height+this.delta.y+"px",this.element.style.width=this.size.width+this.delta.x+"px"):(5<Math.abs(this.delta.x)||5<Math.abs(this.delta.y))&&(e=this.size.top+this.delta.y-window.pageYOffset,t=this.size.left+this.delta.x-window.pageXOffset,this.element.style.top=Math.min(this.size.window.height-100,Math.max(32,e))+"px",this.element.style.left=Math.min(this.size.window.width-this.size.width,Math.max(0,t))+"px")},c.prototype.pointerUp=function(e){document.cookie="wpgb_panel_size="+this.element.clientWidth+","+this.element.clientHeight+","+parseInt(this.element.style.top)+","+parseInt(this.element.style.left),p.handleEvent(this,window,this.pointers.move,"pointerMove",!1),p.handleEvent(this,window,this.pointers.up,"pointerUp",!1),document.body.classList.remove("wpgb-dragging")},[]),q={text:function(e){return(e=p.extend(e,{ID:"text",value:"",placeholder:""})).angle_quotes&&(e.value=e.value.replace(/&lt;/g,"<")),["input",{type:"text",class:"wpgb-input wpgb-text",id:e.uid,name:e.id,value:e.value,placeholder:e.placeholder,autocomplete:"off"}]},url:function(e){return q.text(e)},number:function(e){return["input",{type:"number",class:"wpgb-input wpgb-number",id:(e=p.extend(e,{ID:"number",value:"",min:0,max:"9999",step:1})).uid,name:e.id,value:e.value,min:e.min,max:e.max,step:e.step}]},text_number:function(e){return["input",{type:"text",class:"wpgb-input wpgb-text-number",id:(e=p.extend(e,{ID:"text-number",value:"",min:0,max:9999,step:1,steps:[],units:[],tooltip:""})).uid,name:e.id,value:e.value,"aria-label":e.tooltip,"data-min":e.min,"data-max":e.max,"data-steps":JSON.stringify(e.steps),"data-units":JSON.stringify(e.units),autocomplete:"off"}]},code:function(e){return["textarea",{class:"wpgb-code",id:(e=p.extend(e,{ID:"code",value:"",mode:"javascript",height:"204",placeholder:""})).uid,name:e.id,rows:"5",cols:"25",placeholder:e.placeholder,"data-mode":e.mode,"data-height":e.height,value:e.value}]},slider:function(e){e=p.extend(e,{ID:"slider",value:0,min:0,max:100,step:1,steps:[],units:[]});var t=parseFloat(e.value||0),n=100*(t-e.min)/(e.max-e.min)+.5,n=(""!==e.value?Math.min(100,wpgb_L10n.RTL?100-n:n):0)+"% 100%";return["div",{class:"wpgb-range"},["input",{type:"range",class:"wpgb-input wpgb-range-slider",id:e.uid,style:{"background-size":n},min:e.min,max:e.max,step:.001,"data-steps":JSON.stringify(e.steps),"data-units":JSON.stringify(e.units),value:t}],["input",{type:"text",class:"wpgb-input wpgb-range-slider-value",name:e.id,value:e.value,"aria-label":e.label,autocomplete:"off"}]]},toggle:function(e){return["div",{class:"wpgb-toggle"},["input",{type:"checkbox",class:"wpgb-input wpgb-checkbox",id:(e=p.extend(e,{ID:"switch",value:0})).uid,name:e.id,value:1,checked:e.value}],["span"]]},file:function(e){return["div",{class:"wpgb-upload-file"},["input",{type:"text",id:(e=p.extend(e,{ID:"file",label:"upload",value:0,placeholder:"",mime_type:"image"})).uid,name:e.id,value:e.value,placeholder:e.placeholder,autocomplete:"off"}],["button",{class:"wpgb-button wpgb-button-small wpgb-upload-media",type:"button","data-mime-type":e.mime_type},P.L10n.labels.file_uploader]]},color:function(e){return["div",{class:"wpgb-color","data-gradient":(e=p.extend(e,{ID:"color",value:"",gradient:"",alpha:!1,label:"Select Color",clear:"Clear"})).gradient,"data-alpha":e.alpha},["div",{class:"wpgb-color-picker"},["input",{class:"wpgb-input wpgb-color-picker-input",id:e.uid,name:e.id,value:e.value,readonly:!0}],["span",{class:"wpgb-color-picker-preview",style:{background:e.value}}],["span",{class:"wpgb-color-picker-text"},P.L10n.labels.color_picker]],["div",{class:"wpgb-color-clear"},e.clear]]},font_family:function(e){return e.options["Google Fonts"]=V,U=e.value,e},font_weight:function(t){var e=L[U.replace(/'/g,"")],n=e?e.variants:null;return n&&Object.keys(t.options).forEach(function(e){n.indexOf(e)<0&&"400"!==e&&delete t.options[e]}),t},radio:function(e){var t,n,i,o;if((e=p.extend(e,{ID:"radio",value:"",options:{},icons:{},style:""})).options){for(var r in t="list"===e.style?["ul",{class:"wpgb-radio-list wpgb-list"}]:["div",{class:"wpgb-radio-list"}],e.options)e.options.hasOwnProperty(r)&&(n="wpgb-"+Math.random().toString(36).substr(2,9),i=e.value===r||null,o=e.icons&&e.icons[r]?u.prototype.buildSVGIcon(e.icons[r]):"",t.push(["list"===e.style?"li":"span",{class:"list"===e.style?"wpgb-list-item":"wpgb-radio-item"},["input",{type:"radio",class:"wpgb-input wpgb-radio wpgb-sr-only",id:n,name:e.id,value:r,checked:i}],["label",{for:n},o,["span",e.options[r]]]]));return t}},checkbox:function(e){if((e=p.extend(e,{ID:"checkbox",value:"",options:{},icons:{}})).options){var t,n,i,o,r=["ul",{class:"wpgb-checkbox-list"}],s=Object.keys(e.options).length;for(t in e.options)e.options.hasOwnProperty(t)&&(n="wpgb-"+Math.random().toString(36).substr(2,9),o=e.value===t||null,i=e.icons&&e.icons[t]?u.prototype.buildSVGIcon(e.icons[t]):"",o=[1===s?"div":"li",{class:"wpgb-checkbox-item"},["input",{type:"checkbox",class:"wpgb-input wpgb-checkbox wpgb-sr-only",id:n,name:e.id,value:t,checked:o}],["label",{for:n},i?"":e.options[t],i]],1===s?r=o:r.push(o));return r}},select:function(e){var t=["select",{class:"wpgb-select",id:(e=p.extend(e,{ID:"select",value:"",options:{},multiple:"",placeholder:"",search:"",async:"",validate:!1})).uid,name:e.id,"data-search":e.search,"data-async":e.async,multiple:e.multiple}];if((e="font-family"===(e="font-weight"===e.id?q.font_weight(e):e).id?q.font_family(e):e).options){for(var n in e.placeholder&&t.push(["option",{value:""},e.placeholder]),e.async&&e.value&&!e.options.hasOwnProperty(e.value)&&(e.options[e.value]=e.value),e.options)if(e.options.hasOwnProperty(n)){var i=!!(e.multiple&&e.value&&e.value.length&&-1<e.value.indexOf(n)||e.value===n)||null;if(Array.isArray(e.options[n])||"object"==typeof e.options[n]){var o,r=["optgroup",{label:n}];for(o in e.options[n])e.options[n].hasOwnProperty(o)&&(i=!!(e.multiple&&-1<e.value.indexOf(o)||e.value===o)||null,r.push(["option",{value:o,selected:i},e.options[n][o]]));t.push(r)}else t.push(["option",{value:n,selected:i},e.options[n]])}return t}},icons:function(e){return e=p.extend(e,{ID:"icon",value:"",label:"Select Icon"}),["div",{class:"wpgb-icon"},["div",{class:"wpgb-icon-picker"},["span",{class:"wpgb-icon-picker-svg"}],["span",{class:"wpgb-icon-picker-label"},P.L10n.labels.icon_picker],["input",{type:"hidden",class:"wpgb-input",name:e.id,value:e.value}]]]},notabene:function(e){return e=p.extend(e,{value:""}),["p",{class:"wpgb-nota-bene"},u.prototype.buildSVGIcon(P.icons.info),e.value]},group:function(e){for(var t=["div",{class:"wpgb-field-group wpgb-group-"+e.id}],n=0;n<e.fields.length;n++){var i={class:"wpgb-settings-sub-field wpgb-field-"+e.fields[n].id};e.fields[n].conditional_logic&&(i["data-field-condition"]=JSON.stringify(e.fields[n].conditional_logic)),e.fields[n].uid=1<e.fields.length?"wpgb-"+Math.random().toString(36).substr(2,9):e.uid,t.push(["div",i,e.fields[n].label?["label",{class:"wpgb-field-label",for:e.fields[n].uid},e.fields[n].label]:null,q[e.fields[n].type](e.fields[n])])}return t},blocks:function(e){for(var t=["div",["div",{class:"wpgb-search-field"},u.prototype.buildSVGIcon(P.icons.search),["input",{type:"search",class:"wpgb-input wpgb-search-blocks","aria-label":e.placeholder,placeholder:e.placeholder}]]],n=0;n<wpgb_builder_blocks.length;n++)if(wpgb_builder_blocks[n].blocks){t.push(["h3",wpgb_builder_blocks[n].label]);var i,o,r=["ul",{class:"wpgb-list wpgb-blocks-list wpgb-list-flex"}];for(i in wpgb_builder_blocks[n].blocks)wpgb_builder_blocks[n].blocks.hasOwnProperty(i)&&(o=wpgb_builder_blocks[n].blocks[i],r.push(["li",{class:"wpgb-list-item wpgb-default-block"},u.prototype.buildSVGIcon(e.icons[o.icon]||o.icon||P.icons.custom_block),["span",o.name],["div",u.prototype.buildSVGIcon(P.icons.plus)]]));t.push(r)}return t}},X=(u.prototype.buildSVGIcon=function(e){if(e)return["svg",["use",{"xlink:href":e}]]},u.prototype.buildFields=function(e,t){var n=["div",{class:"wpgb-panel-fields"}];if(e.forEach(function(e){e&&"group"===e.type?e.fields.forEach(function(e){e.value=e.id&&t.hasOwnProperty(e.id)?t[e.id]:void 0!==e.value?e.value:""}):e.value=e.id&&t.hasOwnProperty(e.id)?t[e.id]:void 0!==e.value?e.value:"",n.push("title"===e.type&&e.title?["h3",e.title]:this.buildField(e))}.bind(this)),n[2])return n},u.prototype.buildField=function(e){var t,n={class:"wpgb-settings-field wpgb-field-"+e.id.replace("_","-")};if(q[e.type])return e.conditional_logic&&(n["data-field-condition"]=JSON.stringify(e.conditional_logic)),e.uid="wpgb-"+Math.random().toString(36).substr(2,9),t="radio"!==e.type&&"checbox"!==e.for&&"gallery"!==e.type&&"image"!==e.for,e.label?"group"===e.type&&1<e.fields.length?["div",n,["span",{class:"wpgb-field-label"},e.label,this.buildTooltip(e)],["div",{class:"wpgb-field-input"},q[e.type](e)]]:["div",n,t?["label",{class:"wpgb-field-label",for:e.uid},e.label,this.buildTooltip(e)]:["span",{class:"wpgb-field-label"},e.label,this.buildTooltip(e)],"group"!==e.type?["div",{class:"wpgb-field-input"},q[e.type](e)]:q[e.type](e)]:["div",n,"group"!==e.type?["div",{class:"wpgb-field-input"},q[e.type](e)]:q[e.type](e)]},u.prototype.buildPanel=function(e,t){var n=["div",{class:"wpgb-panel "+(t?"wpgb-draggable-panel ":"")+"wpgb-"+e.id+"-panel",role:"dialog","aria-modal":!0,tabindex:"-1"},e.title?["div",{class:"wpgb-panel-title"},["h3",e.title,["span",{class:"wpgb-block-name"}]],["button",{class:"wpgb-button wpgb-panel-close",type:"button","aria-label":"close"},this.buildSVGIcon(P.icons.cross)]]:""];return e.tabs&&n.push(this.buildTabs(e.tabs)),e.footer&&n.push(this.buildFooter(e.footer)),t&&n.push(["div",{class:"wpgb-handle-resize"}]),n},u.prototype.buildFooter=function(e){var n;if(e.buttons)return n=["div",{class:"wpgb-panel-footer"}],e.buttons.forEach(function(e){var t=["button",{class:"wpgb-panel-button "+e.class,type:"button","aria-label":e.label,"data-tooltip":""}],e=this.buildSVGIcon(P.icons[e.icon]);t.push(e),n.push(t)}.bind(this)),n},u.prototype.buildToggles=function(e,o,r){var s=["div",{class:"wpgb-panel-toggles",role:"presentation"}],a=this.buildSVGIcon(P.icons["chevron-down"]);return e.forEach(function(e,t){var n,i;"accordion"!==e.type||e.tab!==r&&!Array.isArray(e.tab)&&e.tab.indexOf(r)<0||(n=this.hasSettings(e.id,o),i="wpgb-toggle-"+Math.random().toString(36).substr(2,9),s.push(["div",{class:"wpgb-panel-toggle",role:"heading","aria-level":3,"data-wpgb":e.id},["div",{class:"wpgb-panel-toggle-title"},["button",{class:"wpgb-panel-toggle-button",type:"button","aria-expanded":!1,"aria-controls":i},e.title,["span",{class:n?"wpgb-hassettings":""}],a]],["div",{class:"wpgb-panel-toggle-content",id:i,role:"region"}]]))}.bind(this)),s},u.prototype.hasSettings=function(t,e){var n=[];if(e)for(var i=0,o=(n=(n=(n=(n=P.panels.blocks.fields).concat(P.panels.layers.fields)).filter(function(e){return e.id===t&&"accordion"===e.type}))&&n[0]&&n[0].fields).length;i<o;i++){if("group"===n[i].type)for(var r=n[i].fields,s=0,a=r.length;s<a;s++)if(e.hasOwnProperty(r[s].id)&&""!==e[r[s].id])return!0;if(e.hasOwnProperty(n[i].id)&&""!==e[n[i].id])return!0}return!1},u.prototype.buildTabs=function(e){var i=["ul",{class:"wpgb-panel-tabs",role:"tablist"}];return e&&e.length&&e.forEach(function(e,t){var n=e.icon?this.buildSVGIcon(e.icon):"";i.push(["li",{class:"wpgb-panel-tab",role:"tab","aria-selected":t?"false":"true",tabindex:t?"-1":"0","data-wpgb":e.id},n,e.label])}.bind(this)),i},u.prototype.buildTooltip=function(e){if(e.tooltip)return["span",{role:"tooltip","aria-label":e.tooltip,"data-tooltip":"","data-layout":"large"},this.buildSVGIcon(P.icons.info)]},(k=jQuery)(function(){var e="li.wpgb-panel-tab";function t(e,t){var n=0;switch(e.keyCode){case 37:case 38:n=-1;break;case 39:case 40:n=1}n&&(e.preventDefault(),t)&&!function e(t,n){var i=t.parentElement.children;t=1===n?(t=t.nextElementSibling)||i[0]:(t=t.previousElementSibling)||i[i.length-1];if(null===t.offsetParent)return void e(t,n);o(t);t.focus();t.click()}(e.target,n)}function o(e){for(var t=e.parentElement.children,n=0,i=t.length;n<i;n++){var o=e===t[n],r=o?"true":"false";t[n].setAttribute("tabindex",o?"0":"-1"),t[n].setAttribute("aria-selected",r)}}k(document).on("keydown",e,function(e){t(e,!1)}),k(document).on("keyup",e,function(e){t(e,!0)})}),["layout","idle","idlebefore","idleafter","hover","hoverbefore","hoverafter","animate","custom","import","test"]),R=(m.prototype.getStyleSheet=function(e){return(e&&-1<X.indexOf(e)?e:"idle")+"Sheet"},m.prototype.addRules=function(e,t,n){var i;e=this.getStyleSheet(e),"@import"===t?this[e].insertRule(t+" url("+n+")",0):(i=this.rulesExist(e,t,n))?this.addRule(i,n):(n=this.buildRules(n))&&this.insertRules(e,t+"{"+n+"}")},m.prototype.rulesExist=function(e,t,n){for(var i=0,o=(n=this[e].cssRules).length;i<o;i++)if(n[i].selectorText===t)return n[i].style},m.prototype.addRule=function(e,t){if(t)for(var n in t)!t.hasOwnProperty(n)||e.hasOwnProperty(n)&&e[n]===t[n]||e.setProperty(n,t[n])},m.prototype.buildRules=function(e){var t="";if(e)for(var n in e)e.hasOwnProperty(n)&&""!==e[n]&&(t+=n+":"+e[n]+";");return t},m.prototype.insertRules=function(e,t){try{var n=this[e].cssRules.length;this[e].insertRule(t,n)}catch(e){return""}},m.prototype.checkRule=function(e,t){var n=!0,i=".check-rule";try{var o=i+"{"+e+":"+t+"}",r=this.testSheet.cssRules.length;this.testSheet.insertRule(o,r),this.testSheet.cssRules[r].style[e]||(n=!1)}catch(e){this.deleteRules("test",i),n=!1}return this.deleteRules("test",i),n},m.prototype.deleteRules=function(e,t){e=this.getStyleSheet(e);for(var n=this[e].cssRules,i=n.length-1;0<=i;i--)n[i]&&n[i].selectorText&&n[i].selectorText.match(t+"\\b")&&this[e].deleteRule(i)},m.prototype.duplicateRules=function(e,t,n){e=this.getStyleSheet(e);for(var i,o=this[e].cssRules,r=0,s=o.length;r<s;r++){if(!o[r]||!o[r].selectorText)return;o[r].selectorText.match(t+"\\b")&&(i=o[r].cssText.replace(t,n),this.insertRules(e,i))}},m.prototype.getRules=function(e,t){return e=this.getStyleSheet(e),this[e].cssRules},g.element=null,g.prototype.init=function(){this.styleSheet=new m,this.buildCard(),new a,new c,this.bindEvents()},g.prototype.bindEvents=function(){window.addEventListener("wpgb_builder.resize_move",this.onResizeMove.bind(this)),window.addEventListener("wpgb_builder.resize_end",this.onResizeEnd.bind(this)),window.addEventListener("wpgb_builder.sort_start",this.onSortStart.bind(this)),window.addEventListener("wpgb_builder.sort_move",this.onSortMove.bind(this)),window.addEventListener("wpgb_builder.sort_end",this.onSortEnd.bind(this)),document.addEventListener("click",this.click.bind(this)),document.addEventListener("input",this.onChange.bind(this)),document.addEventListener("input",this.searchBlocks.bind(this)),document.addEventListener("change",p.throttle(this.onChange.bind(this))),document.querySelector('[data-action="preview"] input').addEventListener("click",this.previewCard.bind(this),!0),document.querySelector('[data-action="save"]').addEventListener("click",this.saveCard.bind(this),!0),window.addEventListener("beforeunload",this.beforeunload.bind(this))},g.prototype.beforeunload=function(e){if(!0===O)return e.returnValue=wpgb_popup_L10n.beforeunload,e.returnValue},g.prototype.searchBlocks=function(e){e=e.target;if("INPUT"===e.tagName&&"search"===e.type&&e.classList.contains("wpgb-search-blocks")){var t=e.value.toLowerCase(),n=(e.parentElement,document.querySelectorAll(".wpgb-blocks-list")),i=!1;String.prototype.normalize&&(t=t.normalize("NFD").replace(/[\u0300-\u036f]/g,""));for(var o=0,r=n.length;o<r;o++){for(var s=!1,a=n[o].children,l=0,c=a.length;l<c;l++){var d=a[l];-1<d.children[1].textContent.toLowerCase().indexOf(t)?(i=s=!0,d.removeAttribute("style")):d.style.display="none"}s?(n[o].removeAttribute("style"),n[o].previousSibling.removeAttribute("style")):(n[o].style.display="none",n[o].previousSibling.style.display="none")}var p=e.parentNode.nextSibling;p="SPAN"===p.tagName?p:null,!t||i||p?i&&p&&p.parentNode.removeChild(p):((p=document.createElement("span")).textContent=P.L10n.messages.no_results,e.parentNode.parentNode.insertBefore(p,e.parentNode.nextSibling))}},g.prototype.previewCard=function(e){var t=document.querySelector(".wpgb-builder-holder");t.style.display="none",t.classList[this.preview?"remove":"add"]("wpgb-preview"),t.clientHeight;t.style.display="",this.preview=!this.preview},g.prototype.getItemName=function(e){return e=e.match("block")?e.replace("wpgb-block-","Block "):P.L10n.layers[e]||e},g.prototype.refreshCodeMirror=function(){for(var e=document.querySelectorAll(".CodeMirror"),t=0;t<e.length;t++)e[t].CodeMirror.refresh()},g.prototype.getSettings=function(e){var e=p.getParent(e,".wpgb-panel"),t=e.querySelectorAll(".wpgb-panel-tab"),n=N[e.wpgb];if("general"!==e.wpgb){n.hasOwnProperty(this.element)&&n[this.element]?n=n[this.element]:n[this.element]={};for(var i=0;i<t.length;i++)t[i].wpgbActive&&((!n[t[i].wpgb]||Object.keys(n[t[i].wpgb]).length<1)&&(n[t[i].wpgb]={}),n=n[t[i].wpgb])}return n},g.prototype.click=function(e){var t=e.target,n=!!t&&t.previousSibling;"LABEL"!==t.tagName||!n||"radio"!==n.type||["font-style","text-transform","text-decoration","text-align","color_scheme"].indexOf(n.name)<0||n.checked&&(e.preventDefault(),e.stopImmediatePropagation(),n.checked=!n.checked,p.dispatchHTMLEvent(n,"change"))},g.prototype.onChange=function(e){var t=e.target;if(("input"!==e.type||"radio"!==t.type)&&t.name){e=p.getParent(t,".wpgb-panel");if(e){var e=e.querySelectorAll(".wpgb-panel-tab.wpgb-active-tab"),n=t.value,e=e[e.length-1].wpgb,i=this.getSettings(t);if("checkbox"===t.type&&(n=t.checked?1:0),"radio"!==t.type||t.checked||(n=""),"SELECT"===t.tagName&&t.multiple)for(var n=[],o=t.children,r=0,s=o.length;r<s;r++)o[r].selected&&o[r].value&&n.push(o[r].value);i[t.name]=n,"color_scheme"!==t.name&&"color"!==t.name||this.setColorScheme(this.element,e,t),this.onStyleChange(e,t,i),this.onContentChange(e,t,i),this.onLayoutChange(e,t,i),this.formatCustomCSS(e,t,i),O=!0}}},g.prototype.setColorScheme=function(e,t,n){var i=document.querySelector("."+e);if(i.wpgbName&&N.blocks.hasOwnProperty(e)){var o=i.className.match(/wpgb-idle-scheme-([0-9]+)[^\b]*?|wpgb-hover-scheme-([0-9]+)[^\b]*?|wpgb-idle-accent-([0-9]+)[^\b]*?|wpgb-hover-accent-([0-9]+)[^\b]*?/gi),e=N.blocks[e],r=e?e.style:"",s=r&&r.idle?r.idle.color:"",a=r&&r.hover?r.hover.color:"",l=r&&r.hover?r.hover.hover_selector:"",s=r&&r.idle&&!s?r.idle.color_scheme:"",c=r&&r.hover&&!a?r.hover.color_scheme:"";if(o&&o.forEach(function(e){i.classList.remove(e)}),t&&((a="idle"===t?s:c)?e.content[t+"_scheme"]=a:delete e.content[t+"_scheme"]),"hover"!==t||l?"hover_selector"===n.name&&(e.content.hover_scheme=c):delete e.content.hover_scheme,s&&i.classList.add("wpgb-idle-"+s),c&&l&&("post_field"!==e.content.source||"the_terms"!==e.content.post_field))i.classList.add("wpgb-hover-"+c);else if("post_field"===e.content.source&&"the_terms"===e.content.post_field)for(var d=0,p=i.children.length;d<p;d++)i.children[d].classList.contains("wpgb-block-term")&&(i.children[d].className="wpgb-block-term",c)&&l&&i.children[d].classList.add("wpgb-hover-"+c)}},g.prototype.formatCustomCSS=function(e,t,n){if("custom_css"===e){for(var i=this.parseCSS(t.value),o=this.styleSheet.customSheet.rules.length-1,r=0;r<=o;o--)this.styleSheet.customSheet.deleteRule(o);for(o=0,r=i.length;o<r;o++)this.styleSheet.insertRules("customSheet",i[o])}},g.prototype.onStyleChange=function(t,n,i){if(-1<["idle","hover","animation"].indexOf(t)){if("idle"===t||"hover"===t){if(this.formatProperties(n,i),"hover_selector"===n.name)return["","before","after"].forEach(function(e){this.styleSheet.deleteRules(t+e,this.element),n.value&&this.renderStyles(this.element,t,e,i)}.bind(this)),void this.setColorScheme(this.element,t,n);var e=-1<n.name.indexOf("custom_css_")?n.name.replace("custom_css_",""):"";-1<n.name.indexOf("custom_css")&&this.styleSheet.deleteRules(t+e,this.element),this.renderStyles(this.element,t,e,i)}"animation"===t&&(this.animationPresets(n,i),this.formatAnimation(n,i),n&&"selector"===n.name&&this.styleSheet.deleteRules("animate",this.element),n&&"custom"!==i.presets&&n.name.match("transform|translate|rotate|scale|skew|perspective")&&(document.querySelector('[name="presets"][value="custom"]').checked=!0,i.presets="custom"),this.renderAnimation(this.element,i)),this.checkPosition(n,i)}},g.prototype.onContentChange=function(e,t,n){"content"===e&&("source"===t.name&&"raw_content_block"===t.value&&this.refreshCodeMirror(),this.renderContent(this.element,n))},g.prototype.onLayoutChange=function(e,t,n){"general"===e&&t&&"name"!==t.name&&this.formatLayout(n)},g.prototype.formatLayout=function(e){for(var t,n=document.querySelector(".wpgb-card"),i=document.querySelector(".wpgb-card-header"),o=document.querySelector(".wpgb-card-content"),r=document.querySelector(".wpgb-card-footer"),s=document.querySelector(".wpgb-card-media"),a=document.querySelector(".wpgb-card-media-overlay"),l=document.querySelector('.wpgb-edit-layer[data-layer="wpgb-card-media-overlay"]'),c=document.querySelector(".wpgb-builder-holder"),d=document.querySelector(".wpgb-builder-ruler-h"),p=document.querySelector(".wpgb-builder-grid-inner"),u=e.type||"masonry",h=e.content_position,m=e.media_position||"left",g=void 0===e.display_media?1:e.display_media,f=void 0===e.display_overlay?1:e.display_overlay,b=void 0===e.display_footer?1:e.display_footer,y=e.card_layout||"vertical",w=parseInt(e.switch_layout),v=Math.max(300,parseInt(e.card_width,10)||500),_=parseInt(e.media_width,10)||50,S=e.responsive,x=(this.card_layout&&this.card_layout!==y&&(x=(t=document.querySelector('[name="card_width"]')).previousSibling,t.value=e.card_width="vertical"===y?"500px":"1000px",x.value=v=parseFloat(t.value),t=100*(v-x.min)/(x.max-x.min),x.style.backgroundSize=(wpgb_L10n.RTL?100-t:t)+"% 100%"),i.style.display="masonry"!==u||"top"!==h&&"both"!==h?"none":"",o.style.display="masonry"!==u||"bottom"!==h&&"both"!==h?"none":"",s.style.display="masonry"===u&&!g&&h?"none":"",a.style.display=l.style.display=f?"":"none",r.style.display="masonry"!==u||b?"":"none",c.style.width=v+"px",d.style.width=v+"px",p.style.width=v+"px",n.classList.remove("wpgb-horizontal-left","wpgb-horizontal-right"),n.style.fontSize=S?Math.min(v/500*16,999)*("horizontal"===y?.5:1)+"px":"",{"-webkit-box-flex":1,"-ms-flex-positive":1,"flex-grow":1}),k=this.styleSheet.layoutSheet.cssRules.length-1;0<=k;k--)this.styleSheet.layoutSheet.deleteRule(k);"horizontal"===y&&"masonry"===u?(i.style.display="none",o.style.display=s.style.display="",n.classList.add("wpgb-horizontal-"+("right"===m?"left":"right")),this.styleSheet.insertRules("layoutSheet","@media screen and (min-width: "+(w||768)+"px) {"+(".wpgb-card-preview .wpgb-card-inner { -ms-flex-direction: "+("right"===m?"row-reverse":"row")+";-webkit-box-orient: horizontal;-webkit-box-direction: "+("right"===m?"reverse":"normal")+";flex-direction: "+("right"===m?"row-reverse":"row")+";}"+(".wpgb-card-preview .wpgb-card-media { width: "+_+"% }")+(".wpgb-card-preview .wpgb-card-media + .wpgb-card-content { width: "+(100-_)+"% }"))+"}"),this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-content",x)):"vertical"!==y||"masonry"!==u||"bottom"!==h&&"both"!==h?"vertical"===y&&"masonry"===u&&"top"===h?this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-header",x):("vertical"!==y||"masonry"!==u||h)&&"masonry"===u||this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-media",x):this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-content",x),e.flex_media&&"masonry"===u&&(this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-media svg[data-ratio]",{display:"none"}),this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-media-content",{position:"relative",width:"100%"}),this.styleSheet.addRules("layout",".wpgb-card-preview .wpgb-card-media-content-top, .wpgb-card-preview .wpgb-card-media-content-bottom",{position:"relative"})),this.card_layout=y},g.prototype.checkPosition=function(e,t){"position"===e.name&&this.checkDroppables()},g.prototype.animationPresets=function(e,t){if(e&&"presets"===e.name){var n,i,o,r,s,a,l=P.animations[e.value];for(n in l)l.hasOwnProperty(n)&&(i=document.querySelector('.wpgb-draggable-panel [name="'+n+'"]'))&&(i.value=t[n]=l[n],i.classList.contains("wpgb-range-slider-value")&&(r=(o=i.previousSibling).min,s=o.max,a=parseInt(l[n],10),o.value=a,o.style.backgroundSize=100*(a-r)/(s-r)+"% 100%"),"SELECT"===i.tagName)&&p.dispatchHTMLEvent(i,"change")}},g.prototype.onResizeMove=function(e){var t,n={},i={},o=e.detail.element,r=o.parentElement.parentElement,s=N.blocks[o.wpgbName].style.idle;i.width=s.width?(s.width.match(/px|%|em/gi)||["px"]).shift():"px",s.height?"absolute"===s.position?i.height=(s.height.match(/px|%|em/gi)||["px"]).shift():i.height=(s.height.match(/px|em/gi)||["px"]).shift():i.height="px",n.width="%"===i.width?(e.detail.width/r.clientWidth*100).toFixed(2):parseInt(e.detail.width,10),n.height="%"===i.height?(e.detail.height/r.clientHeight*100).toFixed(2):parseInt(e.detail.height,10),"em"!==i.width&&"em"!==i.height||(r=parseFloat(document.querySelector(".wpgb-card").style.fontSize||16),r=s["font-size"]&&s["font-size"].match(/em/gi)?parseFloat(s["font-size"])*r:parseFloat(s["font-size"]||r)*(r/16),n.width="em"===i.width?Number(Math.round(e.detail.width/r+"e6")+"e-6").toFixed(3):n.width,n.height="em"===i.height?Number(Math.round(e.detail.height/r+"e6")+"e-6").toFixed(3):n.height),e.detail.width&&(s.width=parseFloat(n.width)+i.width),e.detail.height&&(s.height=parseFloat(n.height)+i.height),this.element===o.wpgbName&&(r=document.querySelector(".wpgb-block-panel"))&&(n=r.querySelector('.wpgb-input[name="width"]'),t=r.querySelector('.wpgb-input[name="height"]'),n)&&t&&(e.detail.width&&(n.value=s.width),e.detail.height)&&(t.value=s.height)},g.prototype.onResizeEnd=function(e){var e=e.detail.element,t=N.blocks[e.wpgbName].style.idle;this.renderCSS("idle","."+e.wpgbName,"",t),e.removeAttribute("style")},g.prototype.onSortStart=function(e){for(var t=e.detail.element,e=e.detail.droppable,n=e.children,i=!1,o=0,r=n.length;o<r;o++)if(n[o]!==t&&"relative"===window.getComputedStyle(n[o]).getPropertyValue("position")){i=!0;break}i||e.classList.remove("wpgb-filled")},g.prototype.onSortMove=function(e){var t,n,i=e.detail.element,o=i.parentElement.parentElement,r=N.blocks[i.wpgbName].style.idle,s={},a=r.left&&0!==Number(r.left)?r.left.match(/px|em|%/gi).shift():"px",l=r.top&&0!==Number(r.top)?r.top.match(/px|em|%/gi).shift():"px";s.left="%"===a?(e.detail.x/o.clientWidth*100).toFixed(2):parseInt(e.detail.x,10),s.top="%"===l?(e.detail.y/o.clientHeight*100).toFixed(2):parseInt(e.detail.y,10),"em"!==a&&"em"!==l||(o=parseFloat(document.querySelector(".wpgb-card").style.fontSize||16),o=r["font-size"]&&r["font-size"].match(/em/gi)?parseFloat(r["font-size"])*o:parseFloat(r["font-size"]||o)*(o/16),s.left="em"===a?Number(Math.round(e.detail.x/o+"e6")+"e-6").toFixed(3):s.left,s.top="em"===l?Number(Math.round(e.detail.y/o+"e6")+"e-6").toFixed(3):s.top),r.left=parseFloat(s.left)+a,r.top=parseFloat(s.top)+l,this.element===i.wpgbName&&(e=document.querySelector(".wpgb-block-panel"))&&(t=e.querySelector('.wpgb-input[name="left"]'),n=e.querySelector('.wpgb-input[name="top"]'),t)&&n&&(t.value=r.left,n.value=r.top)},g.prototype.onSortEnd=function(e){this.checkDroppables();var t,e=e.detail.element;"absolute"===window.getComputedStyle(e).getPropertyValue("position")&&(t=N.blocks[e.wpgbName].style.idle,this.renderCSS("idle","."+e.wpgbName,"",t),e.removeAttribute("style"))},g.prototype.checkDroppables=function(){for(var e=document.querySelectorAll(".wpgb-droppable"),t=0,n=e.length;t<n;t++){var i=e[t].children;if(e[t].classList.remove("wpgb-filled"),0!==i.length)for(var o=0,r=i.length;o<r;o++)if("relative"===window.getComputedStyle(i[o]).getPropertyValue("position")){e[t].classList.add("wpgb-filled");break}}},(f.prototype=g.prototype).getGoogleFont=function(e){var t,e=e.target;e&&"LI"===e.tagName&&e.classList&&e.classList.contains("wpgb-select-option")&&(e===this.lastFont||"Open Sans"===(t=e.wpgb_value.replace(/'/g,""))||!L[t]||-1<this.fonts.indexOf(t)||(clearTimeout(this.fontTimeout),this.lastFont=e,this.fontTimeout=setTimeout(function(){this.setGoogleFont(t)}.bind(this),400)))},f.prototype.setGoogleFont=function(e){var t,n;"Open Sans"===e||!L[e]||-1<this.fonts.indexOf(e)||(n=L[e],t=Object.keys(L).indexOf(e)+1,n=e.replace(/ /g,"+")+":"+n.variants.join(",")+"&subsets="+n.subsets.join(","),this.fonts.push(e),this.styleSheet.addRules("import","@import","https://fonts.googleapis.com/css?family="+n),this.styleSheet.addRules("import","#wpgb-select-font-family ul > li:last-child li:nth-child("+t+")",{"font-family":"'"+e+"'"}))},f.prototype.getFontWeights=function(e){var t,n,i,o,e=p.getParent(e.target,'.wpgb-select[name="font-family"]');e&&(t=e.value.replace(/'/g,""),n=P.panels.blocks.fields,i={},n.forEach(function(e){"font_accordion"===e.id&&e.fields.forEach(function(e){"font-weight"===e.id&&(i=p.clone(e.options))})}),L[t]&&(t=L[t],o=t.variants,Object.keys(i).forEach(function(e){o.indexOf(e)<0&&"400"!==e&&delete i[e]})),this.setFontWeights(e,i))},f.prototype.setFontWeights=function(e,t){var n,e=p.getParent(e,".wpgb-settings-field").nextSibling.querySelector('select[name="font-weight"]'),i=e.value,o=document.createDocumentFragment();Object.keys(t).forEach(function(e){(n=document.createElement("option")).value=e,n.textContent=t[e],o.appendChild(n)}),p.removeChildren(e),e.appendChild(o),e.querySelector('option[value="'+i+'"]')?e.value=i:e.value=this.findClosestWeight(e,i),p.dispatchHTMLEvent(e,"change"),p.dispatchHTMLEvent(e,"input")},f.prototype.findClosestWeight=function(e,t){for(var n=0,i=400,o=e.children,r=0,s=o.length;r<s;r++){var a=o[r];(!n||Math.abs(a.value-t)<=n)&&(i=a.value,n=Math.abs(a.value-t))}return i},g.prototype.buildCard=function(){var e=N.general,t=N.layers,n=N.blocks,e=(this.formatLayout(e),this.buildCardContent(),p.merge(t,n));this.buildCardCSS(e),this.checkDroppables()},g.prototype.buildCardContent=function(e){for(var t in e=e||wpgb_builder_layout)if(e.hasOwnProperty(t)&&e[t]&&"object"==typeof e[t])if(e[t].hasOwnProperty("blocks")){var n=e[t].blocks,i=document.querySelector(".wpgb-card-"+t);if(n&&i)for(var o=i.querySelector(".wpgb-droppable"),r=0,s=n.length;r<s;r++){var a=n[r],l=document.createElement("div"),a=a.content.name,c=N.blocks[a];c&&c.content&&(l.wpgbName=a,l.className="wpgb-block "+a,o.appendChild(l),this.renderContent(a,c.content),new d(l))}}else this.buildCardContent(e[t])},g.prototype.buildCardCSS=function(e){var n,o;for(n in e)e.hasOwnProperty(n)&&((o=e[n]).animation&&this.renderAnimation(n,o.animation),o.style)&&["idle","hover"].forEach(function(t){o.style.hasOwnProperty(t)&&(r=o.style[t])&&(r["font-family"]&&this.setGoogleFont(r["font-family"].replace(/'/g,"")),["","before","after"].forEach(function(e){this.renderStyles(n,t,e,r)}.bind(this)))}.bind(this));var r=null,t=N.general.global_css,s=this.parseCSS(t);for(i=0,l=s.length;i<l;i++)this.styleSheet.insertRules("customSheet",s[i])},g.prototype.saveCard=function(){C&&C.abort();var n=document.querySelector('[name="wpgb_id"]'),e={inner:{header:"",media:{"media-thumbnail":"","media-overlay":"","media-content":{"media-content-top":"","media-content-center":"","media-content-bottom":""}},content:{body:"",footer:""}}},t=(this.savedFonts={google:{}},this.savedSelectors=[],WPGB_Popup_Message("save_changes","loading"),p.clone(N.general));delete t.name,C=jQuery.ajax({url:ajaxurl,type:"POST",data:{nonce:document.querySelector("#wpgb_fields_nonce").value,action:"wpgb_card",method:"save",object:"settings",id:n.value,settings:JSON.stringify({name:N.general.name,type:N.general.type||"masonry",layout:{settings:this.filterSettings(this.getLayoutSettings(e)),layers:this.filterSettings(this.getLayout(e)),fonts:this.savedFonts},settings:{general:t,layers:this.filterSettings(this.getLayers()),blocks:this.filterSettings(this.getBlocks())},css:this.getStyles()})},context:this,error:function(e){WPGB_Popup_Message("unknown","error")},success:function(e){var t;e.success||e.message?(WPGB_Popup_Message("save_changes",e.success?"success":"error",e.message),window.history&&window.history.pushState&&e.content&&(t=WPGB_Query_String.set({create:"",id:e.content}),window.history.replaceState({},"",t),n.value=e.content)):WPGB_Popup_Message("unknown","error")}}),this.savedFonts=this.savedSelectors=null,O=!1},g.prototype.getLayoutSettings=function(e){return delete(e=this.filterSettings(p.clone(N.general))).name,delete e.global_css,e},g.prototype.getLayout=function(e){for(var t in e)if("object"==typeof e[t]&&e[t]){var n=N.layers["wpgb-card-"+t]||{},i=this.getLayout(e[t]);"media"!==t&&i&&!Object.keys(i).length?delete e[t]:(e[t]=i,e[t].action=n.action||{})}else{i=document.querySelector(".wpgb-card-"+t);if(i&&i.offsetParent){var o=i.querySelectorAll(".wpgb-droppable > .wpgb-block");if(o.length||"media"===t||"media-thumbnail"===t||"media-overlay"===t){n=N.layers["wpgb-card-"+t]||{};e[t]={action:n.action||{},blocks:[]};for(var r=0,s=o.length;r<s;r++){var a=o[r].wpgbName,l=p.clone(N.blocks[a]),c=l.content||{},l=l.action||{};c.name=a,e[t].blocks.push(this.normalizeBlock({content:c,action:l})),this.savedSelectors.push(a),0}}else delete e[t]}else delete e[t]}return e},g.prototype.getLayers=function(e){for(var t={},n=document.querySelectorAll(".wpgb-card .wpgb-layer"),i=0,o=n.length;i<o;i++){var r=n[i];r.offsetParent&&(r=r.classList[0])&&(this.savedSelectors.push(r),N.layers[r])&&(t[r]=N.layers[r])}return this.savedSelectors.push("wpgb-card-media svg[data-ratio]"),this.savedSelectors.push("wpgb-card-media-content-top"),this.savedSelectors.push("wpgb-card-media-content-center"),this.savedSelectors.push("wpgb-card-media-content-bottom"),t},g.prototype.getBlocks=function(e){for(var t,n={},i=0,o=this.savedSelectors.length;i<o;i++)N.blocks[this.savedSelectors[i]]&&(t=p.clone(N.blocks[this.savedSelectors[i]]),n[this.savedSelectors[i]]=this.normalizeBlock(t));return n},g.prototype.normalizeBlock=function(e){if(e.content)switch(e.content.source){case"post_field":delete e.content.product_field,delete e.content.user_field,delete e.content.term_field;break;case"product_field":delete e.content.post_field,delete e.content.user_field,delete e.content.term_field;break;case"term_field":delete e.content.product_field,delete e.content.post_field,delete e.content.user_field;break;case"user_field":delete e.content.product_field,delete e.content.post_field,delete e.content.term_field;break;default:delete e.content.post_field,delete e.content.product_field,delete e.content.user_field,delete e.content.term_field}return e},g.prototype.filterSettings=function(n){var i,t=this;for(i in n)"object"==typeof n[i]&&n[i]?n[i]=Object.keys(n[i]).filter(function(e){return"object"==typeof n[i][e]&&t.filterSettings(n[i]),""!==n[i][e]&&null!==n[i][e]&&void 0!==n[i][e]}).reduce(function(e,t){return e[t]=n[i][t],e},{}):""!==n[i]&&null!==n[i]&&void 0!==n[i]||delete n[i];return n},g.prototype.downloadDefaultBlock=function(e){var t=0,n={};for(i in e){var i,o=(i=e[i]).content,r=o.source||"post_field",o=o[r]||r;n[r="metadata"!==(r="media_button_block"!==r&&"social_share_block"!==r&&"svg_icon_block"!==r?r:"media_content")&&"raw_content_block"!==r&&"custom_block"!==r?r:"custom_content"]||(n[r]={label:r,blocks:{}}),this.normalizeBlock(i),n[r].blocks[t]={name:o,settings:i},t++}var s,e=[];for(s in n)e.push(n[s]);var a=new Blob([JSON.stringify(e)],{type:"octet/stream"}),a=URL.createObjectURL(a),l=document.createElement("a");l.href=a,l.download="default-blocks.json",l.textContent="default-blocks.json",document.body.appendChild(l),l.click()},g.prototype.downloadBlocksSettings=function(e){var t={};for(n in e){var n,i=(n=e[n]).content,o=i.source||"post_field",i=i[o]||o;this.normalizeBlock(n),t[i]=n}var r=new Blob([JSON.stringify(t)],{type:"octet/stream"}),r=URL.createObjectURL(r),s=document.createElement("a");s.href=r,s.download="default-blocks.json",s.textContent="default-blocks.json",document.body.appendChild(s),s.click()},g.prototype.getIcons=function(){for(var e,t=[],n=0,i=this.savedSelectors.length;n<i;n++)N.blocks[this.savedSelectors[n]]&&("svg_icon_block"===(e=N.blocks[this.savedSelectors[n]].content).source?t.push(e.svg_name):"social_share_block"===e.source&&t.push("wpgb/social-media/"+e.social_network));return t&&t.filter(function(e,t,n){return n.indexOf(e)===t})},g.prototype.getStyles=function(e){var t="",n=["layout","idle","idlebefore","idleafter","hover","hoverbefore","hoverafter","animate"];this.savedSelectors=this.orderSelector(this.savedSelectors),arr=[];for(var o,r=0,i=this.savedSelectors.length;r<i;r++)n.forEach(function(e){if(this.styleSheet[e+"Sheet"])for(var t,n=0,i=(o=this.styleSheet[e+"Sheet"].cssRules).length;n<i;n++)o[n]&&o[n].selectorText&&(t=new RegExp("(^|[^\\w-])"+this.savedSelectors[r]+"([^\\w-]|$)","g"),o[n].selectorText.match(t))&&(t=o[n].selectorText.replace(" .wpgb-preview",""),arr[this.savedSelectors[r]]||(arr[this.savedSelectors[r]]={}),arr[this.savedSelectors[r]][t]?arr[this.savedSelectors[r]][t]+=this.autoPrefix(o[n]):arr[this.savedSelectors[r]][t]=this.autoPrefix(o[n]))}.bind(this));for(o in arr)for(var s in arr[o])s.indexOf("wpgb-block-")<0&&(t+=s+" {"+this.removeDuplicateDeclarations(arr[o][s])+"}");for(o in arr)for(var s in arr[o])-1<s.indexOf("wpgb-block-")&&(t+=s+" {"+this.removeDuplicateDeclarations(arr[o][s])+"}");return o=this.styleSheet.layoutSheet.cssRules,t+=this.getMediaStyles(o,!1),o=this.styleSheet.customSheet.cssRules,t=(t+=this.getMediaStyles(o,!0)).replace(/.wpgb-card-preview/g,".wp-grid-builder .wpgb-card-preview")},g.prototype.removeDuplicateDeclarations=function(e){for(var t,n=e.split(";"),i=[],o="",r=0,s=n.length;r<s;r++){var a=n[r].trim().split(/:(.+)/);a[0]&&a[1]&&(i[a[0].trim()]=a[1].trim())}for(t in i)o+=t+": "+i[t]+";";return o},g.prototype.getMediaStyles=function(e,t){for(var n="",i=0,o=e.length;i<o;i++)e[i]&&(e[i].cssText?n+=e[i].cssText.replace(/ .wpgb-preview/g,""):e[i].selectorText&&t&&(n+=e[i].selectorText.replace(" .wpgb-preview","")+"{"+this.autoPrefix(e[i])+"}"));return n},g.prototype.orderSelector=function(e){return e.sort(function(e,t){function n(e){for(var t,n=new Array,i=0,o=-1,r=0;s=(t=e.charAt(i++)).charCodeAt(0);){var s=46==s||48<=s&&s<=57;s!==r&&(n[++o]="",r=s),n[o]+=t}return n}var i,o,r=n(e),s=n(t);for(x=0;r[x]&&s[x];x++)if(r[x]!==s[x])return i=Number(r[x]),o=Number(s[x]),i==r[x]&&o==s[x]?i-o:r[x]>s[x]?1:-1;return r.length-s.length})},g.prototype.autoPrefix=function(e){for(var t=e.cssText.replace(e.selectorText+" {",""),n=(t=t.substring(0,t.length-1)).split(";"),i="",o="",r="",s=0,a=n.length;s<a;s++){var l,c,d=n[s].trim().split(/:(.+)/);d[0]&&d[1]&&(l=d[0].trim(),d=d[1].trim(),"background-position"!==l&&"background-repeat"!==l||"initial initial"!==d)&&("transform"===l||"transition-property"===l||"transition-duration"===l||"transition-delay"===l||"transition-timing-function"===l||"filter"===l||"appearance"===l?i=i+"-webkit-"+l+": "+d+";"+l+": "+d+";":"object-fit"===l?i=i+"-o-"+l+": "+d+";"+l+": "+d+";":"flex-direction"===l?(c=["column","vertical","normal"],"row"===d?c=["row","horizontal","normal"]:"row-reverse"===d&&(c=["row-reverse","horizontal","reverse"]),i=(i=(i=(i+="-ms-flex-direction: "+c[0]+";")+"-webkit-box-orient: "+c[1]+";")+"-webkit-box-direction: "+c[2]+";")+"flex-direction: "+c[0]+";"):"flex-grow"===l?i=(i+="-webkit-box-flex: "+d+";")+"-ms-flex-positive: "+d+";flex-grow: "+d+";":"display"===l&&"flex"===d?i+="display: -webkit-box;display: -ms-flexbox;display: flex;":"flex"===l?i=i+"-ms-flex: "+d+";flex: "+d+";":("font-family"===l&&L[d.replace(/"/g,"")]&&(o=d.replace(/"/g,"")),"font-weight"===l&&(r=parseInt(d,10)),"inset"===l?(void 0!==e.style.top&&""!==e.style.top&&(i+="top: "+e.style.top+";"),void 0!==e.style.right&&""!==e.style.right&&(i+="right: "+e.style.right+";"),void 0!==e.style.bottom&&""!==e.style.bottom&&(i+="bottom: "+e.style.bottom+";"),void 0!==e.style.left&&""!==e.style.left&&(i+="left: "+e.style.left+";")):i+=l+": "+d+";"))}return o&&(this.savedFonts.google[o]=this.savedFonts.google[o]||[],(t=(t=L[o].variants.indexOf(r.toString()))<0&&400===r?L[o].variants.indexOf("regular"):t)<0&&(r=L[o].variants.reduce(function(e,t){return Math.abs(parseInt(t,10)-r)<Math.abs(parseInt(e,!0)-r)?t:e})),-1===this.savedFonts.google[o].indexOf(r))&&this.savedFonts.google[o].push(r),i},g.prototype.renderStyles=function(e,t,n,i){e.match("wpgb-block");var o,r,s=i.hover_selector;if("hover"===t&&(o=this.getParentSelector(e)),e="."+e,-1<["before","after"].indexOf(n)&&(r=i["custom_css"+(n?"_"+n:"")],(i={}).custom_css=r),"hover"===t){if(!s)return;e=((o="card"===s?"":o)||"itself"===s?".wpgb-preview ":".wpgb-preview")+(e="itself"===s?e+":hover":o+":hover "+e)}this.renderCSS(t,e,n,i)},g.prototype.renderCSS=function(e,t,n,i){e+=n,t+=n=n?"::"+n:"",i=p.clone(i),this.validateCustomCSS(n,i),this.setResponsiveFont(n,i),delete i.custom_css,delete i.custom_css_before,delete i.custom_css_after,this.renderFilters(e,t,n,i),this.renderTerms(e,t,n,i),this.styleSheet.addRules(e,".wpgb-card-preview "+t,i)},g.prototype.renderFilters=function(e,t,n,i){i.hasOwnProperty("filter")&&(this.styleSheet.addRules(e,".wpgb-card-preview .wpgb-preview "+t.replace(".wpgb-preview",""),{filter:i.filter}),delete i.filter),i.hasOwnProperty("mix-blend-mode")&&(this.styleSheet.addRules(e,".wpgb-card-preview .wpgb-preview "+t.replace(".wpgb-preview",""),{"mix-blend-mode":i["mix-blend-mode"]}),delete i["mix-blend-mode"])},g.prototype.renderTerms=function(e,t,n,i){var o=t.match(/wpgb-block-(\d*)/);if(o=o?o[0]:null){var r=N.blocks[o];if(r&&r.content&&"post_field"===r.content.source&&"the_terms"===r.content.post_field){var s,a={},l=["position","display","overflow","z-index","clear","float","top","right","bottom","left","width","height","margin-top","margin-right","margin-bottom","margin-left","text-align","line-height","font-size"];for(s in t.indexOf(":hover")<0&&l.push("color"),n&&(l=null),i)"animate"!==e&&(!l||l.indexOf(s)<0)&&(a[s]=i[s],delete i[s]);"animate"===e&&(a.transition=i.transition||""),a&&(n=t.replace(o,o+" .wpgb-block-term"),this.styleSheet.addRules(e,".wpgb-card-preview "+n,a)),"idle"===e&&this.styleSheet.addRules(e,".wpgb-card-preview ."+o+" .wpgb-block-term",{"margin-top":r.content["margin-top"]||"","margin-right":r.content["margin-right"]||"","margin-bottom":r.content["margin-bottom"]||"","margin-left":r.content["margin-left"]||""})}}},g.prototype.renderAnimation=function(e,t){var n,i=this.getParentSelector(e),i="card"===t.selector?"":" "+i,o={opacity:t.opacity<1?t.opacity:"","transition-timing-function":t["transition-timing-function"]||"","transition-duration":t["transition-duration"]||"","transition-delay":t["transition-delay"]||"","transform-origin":t.transform?t["transform-origin"]:"",transform:t.transform||""},r=(t.transform||"").replace(/(translate3d)\((.+?)\)/g,"$1(0,0,0)").replace(/(rotateX)\((.+?)\)/g,"$1(0)").replace(/(rotateY)\((.+?)\)/g,"$1(0)").replace(/(rotateZ)\((.+?)\)/g,"$1(0)").replace(/(scaleX)\((.+?)\)/g,"$1(1)").replace(/(scaleY)\((.+?)\)/g,"$1(1)").replace(/(scaleZ)\((.+?)\)/g,"$1(1)").replace(/(skew)\((.+?)\)/g,"$1(0,0)"),s={opacity:t.opacity<1?1:"",transform:t.transform?r:""};t.reverse&&(s.transform=t.transform||"",o.transform=t.transform?r:"",s.opacity=t.opacity<1?t.opacity:"",o.opacity=t.opacity<1?1:""),this.preview&&(n=document.querySelector(".wpgb-preview ."+e)),this.preview&&n&&(n.style.transition="none"),this.renderCSS("animate",".wpgb-preview ."+e,"",o),this.renderCSS("animate",".wpgb-preview"+i+":hover ."+e,"",s),this.preview&&n&&requestAnimationFrame(function(){setTimeout(function(){n.removeAttribute("style")},0)})},g.prototype.formatAnimation=function(e,t){this.formatTransformOrigin(t),this.formatTransition(t),this.formatTransform(t)},g.prototype.formatProperties=function(e,t){this.formatPosition(e,t),this.formatBoxShadow(e,t),this.formatTextShadow(e,t),this.formatBackgroundImage(e,t),this.formatFilters(e,t)},g.prototype.getParentSelector=function(e){return(e=(e=!!e&&document.querySelector("."+e))&&p.getParent(e.parentElement,".wpgb-layer"))?(e=e.classList).contains("wpgb-card-header")?".wpgb-card-header":e.contains("wpgb-card-media")||e.contains("wpgb-card-media-thumbnail")||e.contains("wpgb-card-media-overlay")||e.contains("wpgb-card-media-content")?".wpgb-card-media":e.contains("wpgb-card-body")||e.contains("wpgb-card-footer")?".wpgb-card-content":"":""},g.prototype.formatPosition=function(e,n){var i,t;if("position"===e.name)return i=e?p.getParent(e,".wpgb-block-panel"):null,"absolute"===n.position?(n.float="",n.display="block",i?(e=i.querySelector('.wpgb-select[name="float"]'),t=i.querySelector('.wpgb-select[name="display"]'),e.value="",t.value="block",p.dispatchHTMLEvent(e,"change"),void p.dispatchHTMLEvent(t,"change")):void 0):void["top","left","bottom","right"].forEach(function(e){var t=i?i.querySelector('.wpgb-input[name="'+e+'"]'):null;t&&(t.value=""),n[e]=""})},g.prototype.formatBoxShadow=function(e,t){var n="",i=[],o={"box-shadow-type":"","box-shadow-horizontal":0,"box-shadow-vertical":0,"box-shadow-blur":0,"box-shadow-spread":0,"box-shadow-color":""};if(o.hasOwnProperty(e.name)){for(var r in o)o.hasOwnProperty(r)&&(t.hasOwnProperty(r)||(t[r]=""),"box-shadow-type"!==r&&(n+=t[r]),r=t[r]||o[r],i.push(r));t["box-shadow"]=""!==n?i.join(" ").trim():""}},g.prototype.formatTextShadow=function(e,t){var n="",i=[],o={"text-shadow-horizontal":0,"text-shadow-vertical":0,"text-shadow-blur":0,"text-shadow-color":""};if(o.hasOwnProperty(e.name)){for(var r in o)o.hasOwnProperty(r)&&(t.hasOwnProperty(r)||(t[r]=""),n+=t[r],r=t[r]||o[r],i.push(r));t["text-shadow"]=""!==n?i.join(" ").trim():""}},g.prototype.formatBackgroundImage=function(e,t){"background-url"===e.name&&(t["background-url"]?t["background-image"]='url("'+t["background-url"]+'")':t["background-image"]="")},g.prototype.validateCustomCSS=function(e,t){if(t.custom_css&&(i=t.custom_css.replace(/.*{([^}]+)}/,"$1"))){var n,i=i.split("\r\n").join("\n").split(";");if(Array.isArray(i))for(n in i)if(i.hasOwnProperty(n)){if(!(r=i[n])||r.indexOf(":")<0)return;var o=(r=r.split(":"))[0].trim(),r=r.slice(1).join(":").trim();if(o.length<1||r.length<1)return;if(!this.styleSheet.checkRule(o,r)||!e&&"position"===o)return;t[o]=r}}},g.prototype.setResponsiveFont=function(e,t){this.setFontSize(t),this.setLineHeight(t)},g.prototype.setFontSize=function(e){var t,n,i="font-size";e.hasOwnProperty(i)&&""!==e[i]&&(n=parseFloat(e[i]||16),n="px"===(t=(t=e[i].toString().match("px|em"))?t.shift():"px")?n/16:n,n=Number(Math.round(n+"e6")+"e-6"),e[i]=n+"em")},g.prototype.setLineHeight=function(e){var t,n,i="line-height";e.hasOwnProperty(i)&&""!==e[i]&&(t=parseFloat(e[i]),n=(n=e[i].toString().match("px|em"))?n.shift():"")&&"em"!==n&&(t/=this.getFontSize(e),e[i]=Number(Math.round(t+"e6")+"e-6")+"em")},g.prototype.getFontSize=function(e){var e=0<parseFloat(e["font-size"])?e["font-size"]:"16px",t=parseFloat(e),e=e.toString().match("px|em");return"em"===(e=e?e.shift():"px")?16*t:t},g.prototype.formatTransition=function(e){var t=e["transition-easing"]||"",n=parseInt(e["transition-duration"]||0,10),i=parseInt(e["transition-delay"]||0,10);"custom"===t&&e["cubic-bezier-function"]&&(t=e["cubic-bezier-function"]||""),e["transition-timing-function"]=t,e["transition-duration"]=0<n?(n+"ms ").trim():"",e["transition-delay"]=0<i?(i+"ms ").trim():""},g.prototype.formatTransformOrigin=function(e){var t,n,i="",o=[],r={"transform-origin-x":"50%","transform-origin-y":"50%","transform-origin-z":0};for(t in r)r.hasOwnProperty(t)&&(e.hasOwnProperty(t)||(e[t]=""),i+=e[t],n=e[t]||r[t],o.push(n));e["transform-origin"]=""!==i?o.join(" ").trim():""},g.prototype.formatTranslate3d=function(e){var t,n,i="",o=[],r={translateX:0,translateY:0,translateZ:0};for(t in r)r.hasOwnProperty(t)&&(e.hasOwnProperty(t)||(e[t]=""),i+=e[t],n=e[t]||r[t],o.push(n));""!==i&&e.transform.push("translate3d("+o.join(",").trim()+")")},g.prototype.formatRotate3d=function(e){var t,n={rotateX:0,rotateY:0,rotateZ:0};for(t in n)n.hasOwnProperty(t)&&(e.hasOwnProperty(t)||(e[t]=""),""!==e[t])&&e.transform.push(t+"("+e[t]+")")},g.prototype.formatScale3d=function(e){var t,n={scaleX:0,scaleY:0,scaleZ:0};for(t in n)n.hasOwnProperty(t)&&(e.hasOwnProperty(t)||(e[t]=""),""!==e[t])&&e.transform.push(t+"("+e[t]+")")},g.prototype.formatSkew2d=function(e){var t,n,i="",o=[],r={skewX:0,skewY:0};for(t in r)r.hasOwnProperty(t)&&(e.hasOwnProperty(t)||(e[t]=""),i+=e[t],n=e[t]||r[t],o.push(n));""!==i&&e.transform.push("skew("+o.join(",").trim()+")")},g.prototype.formatTransformPerspective=function(e){var t=e["transform-perspective"];0<e.transform.length&&0<=parseInt(t,10)&&e.transform.unshift("perspective("+t+")")},g.prototype.formatTransform=function(e){e.transform=[],this.formatTranslate3d(e),this.formatRotate3d(e),this.formatScale3d(e),this.formatSkew2d(e),this.formatTransformPerspective(e),e.transform=e.transform?e.transform.join(" "):""},g.prototype.formatFilters=function(e,t){var n=[],i={"filter-sepia":"","filter-brightness":"","filter-contrast":"","filter-saturate":"","filter-grayscale":"","filter-invert":"","filter-hue-rotate":"","filter-blur":""};if(i.hasOwnProperty(e.name)){for(var o in i)i.hasOwnProperty(o)&&(t.hasOwnProperty(o)||(t[o]=""),""!==t[o])&&n.push(o.replace("filter-","")+"("+t[o]+")");t.filter=n.length?n.join(" ").trim():""}},window.WP_Grid_Builder=new A,window.WP_Grid_Builder.blocks={},window.WP_Grid_Builder.content=g.prototype,window.WP_Grid_Builder.styleSheet={add:function(e){for(selector in e)g.prototype.renderStyles(selector,"idle","",e[selector])},delete:function(e){g.prototype.styleSheet.deleteRules("idle",e)}},b.prototype=g.prototype,b.date=new W,b.lorem_ipsum=["Lorem ipsum dolor sit amet, consectetur adipiscing elit. Praesent dignissim massa nulla, sed accumsan libero imperdiet vitae.","Phasellus quis tincidunt ipsum. Vestibulum blandit massa id nisi rhoncus, eu volutpat sem bibendum. Curabitur ac justo elit. Aliquam nunc massa, accumsan vitae dui id, vestibulum viverra elit.","Donec tincidunt purus lorem, at rhoncus odio venenatis vel. Fusce quis nunc vel libero vulputate ultrices ut ac quam. Sed euismod nibh sit amet neque vulputate efficitur. Integer congue imperdiet mollis."],b.prototype.purifyText=function(e){var t;return""!==e&&((t=document.createElement("div")).innerHTML=DOMPurify.sanitize((e||"").replace(/</g,"&lt;").replace(/>/g,"&gt;"),{ALLOWED_TAGS:[""],KEEP_CONTENT:!0}),t.firstChild)?t.firstChild.nodeValue:""},b.prototype.post_fields={the_id:function(e,t){return document.createTextNode(9)},the_title:function(e,t){return document.createTextNode(T.the_title)},the_name:function(e,t){return document.createTextNode(T.the_name)},the_content:function(e,t){var n=document.createDocumentFragment();return b.lorem_ipsum.forEach(function(e,t){n.appendChild(document.createTextNode(e)),t<2&&(n.appendChild(document.createElement("br")),n.appendChild(document.createElement("br")))}),n},the_excerpt:function(e,t){t=p.extend(t,{excerpt_length:35,excerpt_suffix:""});var n=b.lorem_ipsum.join(" "),i=parseInt(t.excerpt_length,10),t=-1<i?b.prototype.purifyText(t.excerpt_suffix):"";return i=(i=0===(i=isNaN(i)?0:i)?55:i)<=-1?999:i,document.createTextNode(n.split(" ").splice(0,i).join(" ")+t)},the_post_type:function(e,t){return document.createTextNode(T.the_post_type)},the_post_format:function(e,t){return document.createTextNode(T.the_post_format)},the_post_status:function(e,t){return document.createTextNode(T.the_post_status)},the_date:function(e,t){t.format=(t.date_format||T.the_date).trim();t="ago"!==t.format?b.date.getFormat(t.format):T.the_date_ago;return document.createTextNode(t)},the_modified_date:function(e,t){return b.prototype.post_fields.the_date(e,t)},the_terms:function(e,t){t=p.extend(t,{term_glue:""});for(var n=document.createDocumentFragment(),i=0;i<3;i++){var o=document.createElement("span");o.className="wpgb-block-term",o.textContent=T.the_terms+" "+(i+1),n.appendChild(o),t.term_glue&&i<2&&((o=document.createElement("span")).textContent=b.prototype.purifyText(t.term_glue),n.appendChild(o))}return n},the_author:function(e,t){t=t.author_prefix;return document.createTextNode(b.prototype.purifyText((t||"")+T.the_author))},the_avatar:function(e,t){var n=document.createElement("div");return n.className="wpgb-block-avatar",n},comments_number:function(e,t){return t=p.extend(t,{count_format:"text"}),document.createTextNode("number"===t.count_format?2:T.comments_number)}},b.prototype.product_fields={the_price:function(e,t){return document.createTextNode("$99")},the_full_price:function(e,t){var n=document.createDocumentFragment(),i=document.createElement("del"),o=document.createElement("ins"),r=document.createElement("span"),s=document.createElement("span");return i.className=o.className="wpgb-block-price",r.className=s.className="amout",r.textContent="$179",s.textContent="$99",i.appendChild(r),o.appendChild(s),n.appendChild(i),n.appendChild(o),n},the_regular_price:function(e,t){var n=document.createElement("del");return n.textContent="$179",n},the_sale_price:function(e,t){return document.createTextNode("$99")},the_star_rating:function(e,t){var n="http://www.w3.org/2000/svg",i="http://www.w3.org/1999/xlink",o=document.createElementNS(n,"svg"),r=document.createElementNS(n,"use");return o.setAttribute("xmlns",n),o.setAttribute("xmlns:xlink",i),o.setAttributeNS(null,"class","wpgb-icon-rating-stars"),o.setAttributeNS(null,"width","100%"),o.setAttributeNS(null,"height","100%"),o.setAttributeNS(null,"viewbox","0 0 120 24"),r.setAttributeNS(i,"xlink:href",P.icons["rating-stars"]),o.appendChild(r),o},the_text_rating:function(e,t){return document.createTextNode(T.the_text_rating)},the_on_sale_badge:function(e,t){var n={badge_type:"text",badge_icon:"wpgb/business/cart-1",badge_label:T.the_on_sale_badge};return"icon"!==(t=p.extend(t,n)).badge_type?(t.badge_label=b.prototype.purifyText(t.badge_label),document.createTextNode((t.badge_label||"").trim()||T.the_on_sale_badge)):icon=(icon=document.querySelector('.wpgb-icon-item[data-icon="'+t.badge_icon+'"]'))?icon.firstElementChild.cloneNode(!0):null},the_in_stock_badge:function(e,t){return t.badge_label=b.prototype.purifyText(t.badge_label),document.createTextNode((t.badge_label||"").trim()||T.the_in_stock_badge)},the_out_of_stock_badge:function(e,t){return t.badge_label=b.prototype.purifyText(t.badge_label),document.createTextNode((t.badge_label||"").trim()||T.the_out_of_stock_badge)},the_cart_button:function(e,t){return document.createTextNode(T.the_cart_button)}},b.prototype.user_fields={the_user_id:function(e,t){return document.createTextNode(9)},the_user_display_name:function(e,t){return document.createTextNode(T.the_user_display_name)},the_user_first_name:function(e,t){return document.createTextNode(T.the_user_first_name)},the_user_last_name:function(e,t){return document.createTextNode(T.the_user_last_name)},the_user_nickname:function(e,t){return document.createTextNode(T.the_user_nickname)},the_user_login:function(e,t){return document.createTextNode(T.the_user_login)},the_user_description:function(e,t){return b.prototype.post_fields.the_excerpt(e,t)},the_user_email:function(e,t){return document.createTextNode("user@email.com")},the_user_url:function(e,t){return t=p.extend(t,{website_text:""}),document.createTextNode(b.prototype.purifyText(t.website_text)||"https://website.com")},the_user_roles:function(e,t){return document.createTextNode(T.the_user_roles)},the_user_post_count:function(e,t){return t=p.extend(t,{count_format:"text"}),document.createTextNode("number"===t.count_format?10:T.the_user_post_count)}},b.prototype.term_fields={the_term_id:function(e,t){return document.createTextNode(9)},the_term_name:function(e,t){return document.createTextNode(T.the_term_name)},the_term_slug:function(e,t){return document.createTextNode(T.the_term_slug)},the_term_taxonomy:function(e,t){return document.createTextNode(T.the_term_taxonomy)},the_term_parent:function(e,t){return document.createTextNode(T.the_term_parent)},the_term_description:function(e,t){return b.prototype.post_fields.the_excerpt(e,t)},the_term_count:function(e,t){return t=p.extend(t,{count_format:"text"}),document.createTextNode("number"===t.count_format?10:T.the_term_count)}},b.prototype.renderContent=function(e,t){var n=document.querySelector("."+e);if(n){var i=0<n.querySelectorAll("svg").length,o=0<n.querySelectorAll(".wpgb-block-term").length,r="";switch(t.source){case"post_field":var s=document.querySelector('select[name="'+t.source+'"]'),r=t.post_field=t.post_field||s&&s.value||"the_id";this.post_fields.hasOwnProperty(r)&&(c=this.post_fields[r](n,t));break;case"product_field":s=document.querySelector('select[name="'+t.source+'"]');r=t.product_field=t.product_field||s&&s.value||"the_full_price",this.product_fields.hasOwnProperty(r)&&(c=this.product_fields[r](n,t));break;case"user_field":s=document.querySelector('select[name="'+t.source+'"]');r=t.user_field=t.user_field||s&&s.value||"the_user_id",this.user_fields.hasOwnProperty(r)&&(c=this.user_fields[r](n,t));break;case"term_field":s=document.querySelector('select[name="'+t.source+'"]');r=t.term_field=t.term_field||s&&s.value||"the_term_id",this.term_fields.hasOwnProperty(r)&&(c=this.term_fields[r](n,t));break;case"metadata":r="metadata";var a=b.prototype.purifyText(t.meta_prefix||""),l=b.prototype.purifyText(t.meta_suffix||""),c=document.createTextNode(a+"{{ "+(t.meta_key||T.metadata)+" }}"+l);break;case"media_button_block":r="media_button_block";var d=t.lightbox_icon||"wpgb/user-interface/add";c=(c=document.querySelector('.wpgb-icon-item[data-icon="'+d+'"]'))?c.firstElementChild.cloneNode(!0):null;break;case"social_share_block":r="social_share_block",c=(c=document.querySelector('.wpgb-icon-item[data-icon="wpgb/social-media/'+(t.social_network||"facebook")+'"]'))?c.firstElementChild.cloneNode(!0):null;break;case"svg_icon_block":r="svg_icon_block";d=t.svg_name||"wpgb/animals/bug";c=(c=document.querySelector('.wpgb-icon-item[data-icon="'+d+'"]'))?c.firstElementChild.cloneNode(!0):null;break;case"raw_content_block":r="raw_content_block",(c=document.createElement("div")).innerHTML=DOMPurify.sanitize(t.raw_content);break;case"custom_block":r="custom_block";a=t.block_name||"",l=P.panels.blocks.fields.filter(function(e){return"block_name"===e.id}),a=l[0]&&l[0].hasOwnProperty("options")?a&&l[0].options.hasOwnProperty(a)?"{{ "+l[0].options[a]+" }}":"*** "+T.custom_block.not_selected+" ***":"*** "+T.custom_block.not_founded+" ***";c=document.createTextNode(a);break;default:var p=t.source,s=document.querySelector('select[name="'+p+'"]'),d=!t[p]&&P.panels.blocks.fields.filter(function(e){return e.id===p});d&&d[0]&&(t[p]=d[0].options&&Object.keys(d[0].options)[0]),c=(r=t[p])&&WP_Grid_Builder.blocks[r]&&WP_Grid_Builder.blocks[r](t,e,n),r&&!c?c=document.createTextNode("{{ "+r+" }}"):r||(c=document.createTextNode("*** "+T.not_founded+" ***"))}var u=n.firstElementChild;u&&c&&u.isEqualNode(c)||(this.removeContent(n),c&&n.insertBefore(c,n.firstElementChild)),this.setClassName(n,t),this.iconStroke(n,i,e,t),this.termsStyles(n,o,e,t),this.termsSpacing(e,t),WP_Grid_Builder.emit("blockRendered",[r,t,e,n])}},b.prototype.removeContent=function(e){for(var t=e.childNodes,n=t.length-1;0<=n;n--)t[n].classList&&t[n].classList.contains("wpgb-resizer")||t[n].parentNode.removeChild(t[n])},b.prototype.setClassName=function(e,t){for(var n=t.class,i=e.classList,o=new RegExp("^wpgb-block$|^"+e.wpgbName+"$|wpgb-idle-scheme-([0-9]+)[^\b]*?|wpgb-hover-scheme-([0-9]+)[^\b]*?|wpgb-idle-accent-([0-9]+)[^\b]*?|wpgb-hover-accent-([0-9]+)[^\b]*?","gi"),r=i.length-1,s=0;s<=r;r--)i[r].match(o)||i[r]&&e.classList.remove(i[r]);if(this.setColorScheme(e.wpgbName,"",""),n)for(var a=n.trim().split(/\s+/),r=0,s=a.length;r<s;r++)if(n=(n=(n=a[r]).replace(/|%[a-fA-F0-9][a-fA-F0-9]|/g,"")).replace(/[^A-Za-z0-9_-]/g,"").trim())try{i.add(n)}catch(e){}},b.prototype.iconStroke=function(e,t,n,i){e=0<e.querySelectorAll("svg").length;!0===t&&!1==e?(N.blocks[n].style.idle["stroke-width"]="",this.renderStyles(n,"","",{"stroke-width":""})):!0==e&&(N.blocks[n].style.idle["stroke-width"]=i["stroke-width"]||1,this.renderStyles(n,"","",{"stroke-width":i["stroke-width"]||1}))},b.prototype.termsSpacing=function(e,t){"the_terms"===t.post_field&&this.renderStyles(e+" .wpgb-block-term","","",{"margin-top":t["margin-top"]||"","margin-right":t["margin-right"]||"","margin-bottom":t["margin-bottom"]||"","margin-left":t["margin-left"]||""})},b.prototype.termsStyles=function(e,t,n,i){t!==0<e.querySelectorAll(".wpgb-block-term").length&&(i=N.blocks[n].style,["idle","hover"].forEach(function(t){i.hasOwnProperty(t)&&["","before","after"].forEach(function(e){this.styleSheet.deleteRules(t+e,n),this.renderStyles(n,t,e,i[t])}.bind(this))}.bind(this)))},g.prototype.cssKeyframe="((@.*?keyframes [\\s\\S]*?){([\\s\\S]*?}\\s*?)})",g.prototype.cssCombined="((\\s*?(?:\\/\\*[\\s\\S]*?\\*\\/)?\\s*?@media[\\s\\S]*?){([\\s\\S]*?)}\\s*?})|(([\\s\\S]*?){([\\s\\S]*?)})",g.prototype.cssImport=new RegExp("@import .*?;","gi"),g.prototype.parseCSS=function(e){if(void 0===e)return[];for(var t,n=[];null!==(t=this.cssImport.exec(e));)n.push(t[0]);e=e.replace(this.cssImport,"");for(var i=new RegExp(this.cssKeyframe,"gi");null!==(t=i.exec(e));)n.push(t[0]);e=e.replace(i,"");for(var o=new RegExp(this.cssCombined,"gi");null!==(t=o.exec(e));){var r,s=void 0===t[2]?t[5]:t[2];-1!==(s=(s=s.split("\r\n").join("\n").trim()).replace(/\n+/,"\n")).indexOf("@media")?(r=this.parseCSS(t[3]+"\n}"),n.push(s+"{"+r.join("")+"}")):n.push(".wpgb-card-preview .wpgb-preview "+s+"{"+t[6]+"}")}return n},((y.prototype=Object.create(g.prototype)).constructor=y).prototype.bindEvents=function(){this.mobile=window.innerWidth<=1280,window.addEventListener("resize",this.switchEditor.bind(this)),window.addEventListener("click",this.onClick.bind(this),!0),window.addEventListener("click",this.closePanel.bind(this),!0),window.addEventListener("click",this.appendLayerPanel.bind(this),!0);for(var e=document.querySelectorAll(".wpgb-edit-layer-menu li"),t=0;t<e.length;t++)e[t].addEventListener("mouseenter",this.highlightLayer.bind(this,!0)),e[t].addEventListener("mouseleave",this.highlightLayer.bind(this,!1))},y.prototype.switchEditor=function(){var e=window.innerWidth,t=document.querySelector(".wpgb-card-panel > ul > li:nth-child(2)"),n=document.querySelector(".wpgb-card-panel > ul > li:nth-child(1)");e<=1280&&!this.mobile?(t.click(),this.mobile=!0):1280<e&&this.mobile&&(t.classList.contains("wpgb-active-tab")&&n.click(),this.mobile=!1)},y.prototype.onClick=function(e){var t=p.getParent(e.target,".wpgb-panel-toggle-title");t?(t=t.parentElement,this.renderToggle(t,t.wpgb),this.initHelpers()):(t=p.getParent(e.target,".wpgb-panel-tab"))&&!t.wpgbActive&&(p.getParent(e.target,".wpgb-card-panel")&&document.querySelector(".wpgb-builder-right-panel").classList["editor"===t.wpgb?"add":"remove"]("wpgb-reveal-editor"),this.renderTabContent(t,t.wpgb),this.initHelpers())},y.prototype.appendGeneralPanel=function(){var e="general",t=P.panels;t=t[e],t=this.framework.buildPanel(t),(t=this.view.render(t)).wpgb=e,this.renderTabContent(t.querySelector(".wpgb-panel-tab")),document.querySelector(".wpgb-builder-left-panel").appendChild(t),this.initHelpers()},y.prototype.initHelpers=function(){requestAnimationFrame(function(){setTimeout(function(){WPGB_Select_Init(),WPGB_Tooltip_Init(),WPGB_Gradient_Init()},0)}),p.dispatchEvent(window,"wpgb_builder.render_field")},y.prototype.renderToggle=function(e,n,t){var i,o=p.getParent(e,".wpgb-panel"),r=o.querySelector(".wpgb-active-toggle"),s=(s=o.querySelectorAll(".wpgb-active-tab"))[s.length-1].wpgb;r&&(i=N[o.wpgb][this.element].style["style"===s?"idle":s],i=this.framework.hasSettings(r.wpgb,i),r.querySelector(".wpgb-panel-toggle-title span").classList[i?"add":"remove"]("wpgb-hassettings")),e.classList.contains("wpgb-active-toggle")?this.removeToggle(e):(this.removeToggle(e),e.classList.add("wpgb-active-toggle"),e.querySelector(".wpgb-panel-toggle-button").setAttribute("aria-expanded",!0),i=this.getSettings(e),r=e.lastElementChild,(o=(o=(o=(o=(o=p.clone(P.panels[o.wpgb].fields)).filter(function(e){var t=e.tab===s||Array.isArray(e.tab)&&-1<e.tab.indexOf(s),e="accordion"===e.type&&e.id===n;return t&&e}))&&o[0]&&o[0].fields)&&this.framework.buildFields(o,i))&&this.view.render(o))&&r.appendChild(o),!1!==t&&G(e))},y.prototype.removeToggle=function(e){for(var t=e.parentNode.querySelectorAll(".wpgb-panel-toggle-content"),n=0;n<t.length;n++)t[n].parentElement.classList.remove("wpgb-active-toggle"),t[n].previousElementSibling.firstElementChild.setAttribute("aria-expanded",!1),p.removeChildren(t[n])},y.prototype.appendPanel=function(e,t){g.prototype.element=t;var n=document.querySelector(".wpgb-draggable-panel");n&&n.wpgb===e?(n.querySelector(".wpgb-block-name").textContent="("+this.getItemName(t)+")",this.replacePanel(n)):(n&&(this.removePanel(),g.prototype.element=t),n=(n=(n=P.panels)[e]).hasOwnProperty(t)?n[t]:n,n=this.framework.buildPanel(n,!0),(n=this.view.render(n)).wpgb=e,n.querySelector(".wpgb-block-name").textContent="("+this.getItemName(t)+")",e=this.getPanelCookie(),n.style.height=e.height+"px",n.style.width=e.width+"px",this.panelPosition?(n.style.left=this.panelPosition.left,n.style.top=this.panelPosition.top):(n.style.top=Math.max(46,e.top||document.body.clientHeight/2-e.height/2+32)+"px",n.style.left=Math.max(0,e.left||document.body.clientWidth/2-e.width/2)+"px"),t=n.querySelector(".wpgb-panel-tab"),this.renderTabContent(t),document.querySelector(".wpgb-builder-right-panel").appendChild(n),t.focus(),this.updateItemList()),this.initHelpers()},y.prototype.getPanelCookie=function(){var e=new RegExp("wpgb_panel_size=(.*?);");return e=(e=document.cookie.match(e))&&e[1]?e[1].split(","):[440,650,null,null],{width:Math.min(document.body.clientWidth,e[0]),height:Math.min(document.body.clientHeight,e[1]),top:e[2],left:e[3]}},y.prototype.appendLayerPanel=function(e){var t,n=document.querySelector(".wpgb-card-media .wpgb-edit-layer"),e=p.getParent(e.target,".wpgb-edit-layer");if(e)if(e.querySelector(".wpgb-edit-layer-menu"))if(n.classList.toggle("wpgb-active"),n.classList.contains("wpgb-active")){for(var i=n.querySelectorAll("li"),o=0;o<i.length;o++){var r=i[o].getAttribute("data-layer");i[o].classList[this.element===r?"add":"remove"]("wpgb-selected")}this.layerPerspective(!0)}else this.layerPerspective(!1);else if((t=e.getAttribute("data-layer"))===this.element)n.classList.remove("wpgb-active"),this.layerPerspective(!1);else{this.layerPerspective(!1),this.appendPanel("layers",t);var s=document.querySelectorAll(".wpgb-edit-layer.wpgb-show");if(s)for(var o=0,a=s.length;o<a;o++)s[o].classList.remove("wpgb-show");e="LI"===e.tagName?p.getParent(e.parentElement,".wpgb-edit-layer"):e,n.classList.remove("wpgb-active"),e.classList.add("wpgb-show")}else n.classList.remove("wpgb-active"),this.layerPerspective(!1)},y.prototype.addIcon=function(e){for(var t=e.querySelectorAll(".wpgb-icon-picker input.wpgb-input"),n=0,i=t.length;n<i;n++){var o,r=t[n];r.value&&(o=(o=document.querySelector('.wpgb-icon-item[data-icon="'+r.value+'"]'))?o.firstElementChild.cloneNode(!0):null)&&r.parentElement.querySelector(".wpgb-icon-picker-svg").appendChild(o)}},y.prototype.replacePanel=function(e){var t=e.querySelectorAll(".wpgb-active-tab"),n=e.querySelectorAll(".wpgb-active-toggle"),i=(n=n[n.length-1])?Array.prototype.indexOf.call(n.parentNode.children,n):null,o=t?t[t.length-1].parentElement.nextSibling.scrollTop:0;t.length&&(t=t[t.length-1],this.renderTabContent(t,t.wpgb,!1)),n&&0<=i&&(n=e.querySelectorAll(".wpgb-panel-toggle")[i],this.renderToggle(n,n.wpgb,!1),t.parentElement.nextSibling.scrollTop=o),this.updateItemList()},y.prototype.closePanel=function(e){p.getParent(e.target,".wpgb-panel-close")&&(this.removePanel(e),this.updateItemList())},y.prototype.removePanel=function(){var e,t,n;this.element&&(e=document.querySelector(".wpgb-draggable-panel"),document.querySelector("."+this.element),e)&&(this.panelPosition={left:e.style.left,top:e.style.top},t=document.querySelector(".wpgb-resizer.wpgb-show"),n=document.querySelector(".wpgb-edit-layer.wpgb-show"),t&&t.classList.remove("wpgb-show"),n&&n.classList.remove("wpgb-show"),e.parentNode.removeChild(e),g.prototype.element=null)},y.prototype.renderTabContent=function(e,t){if(e){for(var n=e.parentNode.children,i=p.getParent(e,".wpgb-panel"),o=0,r=n.length;o<r;o++)n[o].classList.remove("wpgb-active-tab"),n[o].wpgbActive=0;e.classList.add("wpgb-active-tab"),e.wpgbActive=1,(n=e.parentElement).nextSibling&&n.nextSibling.classList.contains("wpgb-panel-content")&&n.nextSibling.parentNode.removeChild(n.nextSibling);e=this.getSettings(e),i=this.getTabContent(i.wpgb,t,e);i&&(this.addIcon(i),n.parentNode.insertBefore(i,n.nextSibling))}},y.prototype.getTabContent=function(e,t,n){var i,o,r,s=[],a=document.createDocumentFragment(),l=p.clone(P).panels,l=l?l[e]:null,c=(l.hasOwnProperty(this.element)&&(l=l[this.element]),this.searchTabContent(l,t));if(c)return(o=l.tabs.filter(function(e){return e.id===t}))&&o[0]&&o[0].tabs&&(i=this.framework.buildTabs(o[0].tabs),(i=this.view.render(i)).firstElementChild.classList.add("wpgb-active-tab"),i.firstElementChild.wpgbActive=1,c=this.searchTabContent(l,o[0].tabs[0].id),t=o[0].tabs[0].id),c.fields&&(s=c.fields,r=(o=(o=this.element&&N[e][this.element])&&o.content)&&o.source,"blocks"===e&&"action"===t&&("media_button_block"===r||"social_share_block"===r||"user_field"===r&&"the_user_url"===o.user_field||"user_field"===r&&"the_user_email"===o.user_field||"product_field"===r&&"the_cart_button"===o.product_field||"post_field"===r&&"the_terms"===o.post_field&&o.term_link?s=s.slice(0,1):s.shift()),s=(s=s&&this.framework.buildFields(s,n))&&this.view.render(s))&&a.appendChild(s),"idle"!==t&&"hover"!==t||(n=(n=N[e][this.element].style)?n["style"===t?"idle":t]:null,r=this.framework.buildToggles(c.fields,n,t),r=this.view.render(r),a.appendChild(r)),a?(l=this.view.render(["div",{class:"wpgb-panel-content"}]),i?((c=l.cloneNode()).appendChild(a),l.appendChild(i),l.appendChild(c)):l.appendChild(a),l):void 0},y.prototype.searchTabContent=function(e,t){var n={fields:[]};return t=t||e.tabs[0].id,e.fields.forEach(function(e){(e.tab===t||Array.isArray(e.tab)&&-1<e.tab.indexOf(t))&&n.fields.push(e)}.bind(this)),n},y.prototype.layerPerspective=function(e){var t,n,i=document.querySelector(".wpgb-card-media"),o=document.querySelectorAll(".wpgb-card-media, .wpgb-card-media > .wpgb-layer");e=!document.querySelector(".wpgb-preview")&&e;for(var r=0;r<o.length;r++)t=o[r],e?t.querySelector(".wpgb-layer-highlight")||((n=document.createElement("div")).className="wpgb-layer-highlight",t.appendChild(n)):(n=t.lastElementChild)&&n.classList.contains("wpgb-layer-highlight")&&t.removeChild(n);i.style.perspective=e?2.4*i.clientWidth+"px":null,setTimeout(function(){i.classList[e?"add":"remove"]("wpgb-layers-perspective")},0)},y.prototype.highlightLayer=function(e,t){t=t.target.getAttribute("data-layer"),t=document.querySelector("."+t);t&&t.classList[e?"add":"remove"]("wpgb-show")},(w.prototype=y.prototype).openList=function(e){var t=document.querySelector(".wpgb-builder-list ul"),e=p.getParent(e.target,".wpgb-builder-list");t?(t.parentNode.classList.remove("wpgb-list-open"),t.parentNode.removeChild(t),t=null):e&&(t=document.querySelector(".wpgb-card"),t=this.buildList(t,!1),this.layerPerspective(!0),e.classList.add("wpgb-list-open"),e.appendChild(t))},w.prototype.buildList=function(e,t){var n=t||document.createElement("ul"),i=e.children;if(i){for(var o=0,r=i.length;o<r;o++){var s,a=i[o],l=p.matchesSelector(a,".wpgb-layer"),c=p.matchesSelector(a,".wpgb-block"),d=this.buildList(a,!l&&n);!c&&!l||a&&"none"===a.style.display||("wpgb-card-content"===(s=c?a.wpgbName:a.classList[0])?d&&n.appendChild(d):(l&&(l=this.getListItem(a,"layer",s),n.appendChild(l)),d&&l&&(l||n).appendChild(d),c&&(c=this.getListItem(a,"block",s),n.appendChild(c))))}return n}},w.prototype.getListItem=function(e,t,n){var i=N.blocks[n],i=i?i.content:null,o=i?i.source||"post_field":null,i=i&&"custom_block"===o?i.block_name||o:i&&i[o]?i[o]:o,o=R[i],i=D[i],r=document.createElement("li"),s=document.createElement("span"),o=o?o+" ("+n.replace("wpgb-block-","")+")":this.getItemName(n),i=(i=i||"block"!==t?i||P.icons.layer:P.icons.custom_block,this.view.render(["svg",["use",{"xlink:href":i}]]));return s.className="wpgb-builder-list-"+t+(this.element===n?" wpgb-selected":""),s.wpgbName=n,s.appendChild(i),s.appendChild(document.createTextNode(o)),s.addEventListener("click",this.selectItem.bind(this)),s.addEventListener("mouseenter",this.revealItem.bind(this,"add")),s.addEventListener("mouseleave",this.revealItem.bind(this,"remove")),r.appendChild(s),r},w.prototype.selectItem=function(e){this.revealItem("remove",e);var t=document.querySelector("."+e.target.wpgbName);t.classList.contains("wpgb-block")?t.click():(t=document.querySelector('[data-layer="'+e.target.wpgbName+'"]'))&&t.click()},w.prototype.updateItemList=function(){var e=document.querySelector(".wpgb-builder-list"),t=e.querySelector("span"),n=(this.placeholder||(this.placeholder=t.textContent),this.element?this.getItemName(this.element):this.placeholder);e.classList[this.element?"add":"remove"]("wpgb-selected"),t.textContent=n},w.prototype.revealItem=function(e,t){var n,t=document.querySelector("."+t.target.wpgbName);!t||this.element&&t.wpgbName===this.element||(t=(n=t.lastElementChild)&&n.classList.contains("wpgb-resizer")?n:t).classList[e]("wpgb-show")},((v.prototype=Object.create(y.prototype)).constructor=v).prototype.blockActions=function(e){e=p.getParent(e.target,".wpgb-panel-button");if(e){e=e.classList;if(e=e[1]||null){var t=document.querySelector("."+this.element);if(t)switch(e){case"wpgb-delete-block":this.deleteBlock(t);break;case"wpgb-duplicate-block":this.duplicateBlock(t);break;case"wpgb-move-up-block":this.moveUpBlock(t);break;case"wpgb-move-down-block":this.moveDownBlock(t)}}}},v.prototype.uniqueName=function(e){for(var t,n,i=N.blocks,o=1;t=i[n=e+"-"+o],o++,t;);return n},v.prototype.selectBlock=function(e){if(3!=e.which){e=p.getParent(e.target,".wpgb-block");if(e&&e.wpgbName!==this.element){this.appendPanel("blocks",e.wpgbName);for(var e=e.querySelector(".wpgb-resizer"),t=document.querySelectorAll(".wpgb-resizer.wpgb-show"),n=0,i=t.length;n<i;n++)t[n].classList.remove("wpgb-show");e&&e.classList.add("wpgb-show")}}},v.prototype.addBlock=function(e){e=p.getParent(e.target,".wpgb-default-block");if(e){for(var t,n=Array.prototype.indexOf.call(document.querySelectorAll(".wpgb-default-block"),e),e=this.uniqueName("wpgb-block"),i=document.createElement("div"),o=(document.createElement("div"),document.querySelectorAll(".wpgb-layer .wpgb-droppable")),r=0,s=o.length;r<s;r++)if(o[r].offsetParent){t=o[r];break}if(t){i.wpgbName=e,i.className="wpgb-block "+e,t.firstElementChild?t.insertBefore(i,t.firstElementChild):t.appendChild(i);for(var a={},r=0,s=wpgb_builder_blocks.length;r<s;r++){var l=wpgb_builder_blocks[r].blocks;if(l&&l.hasOwnProperty(n)){a=l[n].settings;break}}N.blocks||(N.blocks=[]),N.blocks[e]=p.clone(a);var c={};c[e]=N.blocks[e],this.renderContent(e,N.blocks[e].content),this.buildCardCSS(c),this.checkDroppables(),new d(i),O=!0}}},v.prototype.duplicateBlock=function(e){var t,n,i=e?e.wpgbName:null;i&&(t=e.cloneNode(!0),n=this.uniqueName("wpgb-block"),t.querySelector(".wpgb-resizer")&&t.removeChild(t.querySelector(".wpgb-resizer")),t.className=t.className.replace(i,n),t.wpgbName=n,new d(t),N.blocks[n]=p.clone(N.blocks[i]),this.styleSheet.duplicateRules("idle",i,n),this.styleSheet.duplicateRules("idlebefore",i,n),this.styleSheet.duplicateRules("idleafter",i,n),this.styleSheet.duplicateRules("hover",i,n),this.styleSheet.duplicateRules("hoverbefore",i,n),this.styleSheet.duplicateRules("hoverafter",i,n),this.styleSheet.duplicateRules("animate",i,n),e.parentNode.insertBefore(t,e.nextSibling),this.checkDroppables(),O=!0)},v.prototype.deleteBlock=function(t){WPGB_Dialog(wpgb_dialog_L10n.delete_block,function(){var e=t?t.wpgbName:null;e&&t.parentElement&&(e===this.element&&this.removePanel(),t.parentElement.removeChild(t),delete N.blocks[e],this.styleSheet.deleteRules("idle",e),this.styleSheet.deleteRules("idlebefore",e),this.styleSheet.deleteRules("idleafter",e),this.styleSheet.deleteRules("hover",e),this.styleSheet.deleteRules("hoverbefore",e),this.styleSheet.deleteRules("hoverafter",e),this.styleSheet.deleteRules("animate",e),e===this.element&&(this.element=null),this.checkDroppables())}.bind(this)),O=!0},v.prototype.moveUpBlock=function(e){var t=window.getComputedStyle(e).getPropertyValue("position"),n=document.querySelectorAll(".wpgb-droppable"),i=e.previousSibling;if(O=!0,"absolute"!==t&&i)e.parentNode.insertBefore(e,i);else{for(var o,r=Array.prototype.indexOf.call(n,e.parentNode);!o||!o.offsetParent;)o=n[p.modulo(n.length,--r)];o.appendChild(e)}this.checkDroppables()},v.prototype.moveDownBlock=function(e){var t=window.getComputedStyle(e).getPropertyValue("position"),n=document.querySelectorAll(".wpgb-droppable"),i=e.nextSibling;if(O=!0,"absolute"!==t&&i)e.parentNode.insertBefore(e,i.nextSibling);else{for(var o,r=Array.prototype.indexOf.call(n,e.parentNode);!o||!o.offsetParent;)o=n[p.modulo(n.length,++r)];o.insertBefore(e,o.firstChild)}this.checkDroppables()},((_.prototype=Object.create(v.prototype)).constructor=_).prototype.reveal=function(e){this.hide();var t=p.getParent(e.target,".wpgb-block");t&&(e.preventDefault(),this.block=t,this.renderMenu(e))},_.prototype.hide=function(e){this.select(e),this.menu&&this.menu.parentNode&&this.menu.parentNode.removeChild(this.menu)},_.prototype.select=function(e){e=e?p.getParent(e.target,".wpgb-context-menu-item"):null;if(e)switch(Array.prototype.indexOf.call(e.parentNode.childNodes,e)){case 0:this.block.click();break;case 1:this.duplicateBlock(this.block);break;case 2:this.deleteBlock(this.block)}},_.prototype.renderMenu=function(e){var t=P.icons,n=P.L10n.contextMenu,e={top:e.pageY+15+"px",left:e.pageX-20+"px"};this.menu=this.view.render(["div",{class:"wpgb-context-menu",style:e},["ul",{class:"wpgb-context-menu-list"},["li",{class:"wpgb-context-menu-item"},["svg",["use",{"xlink:href":t.settings}]],n.edit],["li",{class:"wpgb-context-menu-item"},["svg",["use",{"xlink:href":t.clipboard}]],n.duplicate],["li",{class:"wpgb-context-menu-item"},["svg",["use",{"xlink:href":t.delete}]],n.delete]]]),document.body.appendChild(this.menu)},[]),D=[];function $(){var e=document.querySelector(".wpgb-builder-right-panel");e.style.minHeight=window.innerHeight-window.pageYOffset-e.getBoundingClientRect().top-20+"px"}new n(".wpgb-builder-ruler-h canvas","horizontal"),new n(".wpgb-builder-ruler-v canvas","vertical"),document.body.classList.add("wpgb-card-preview"),jQuery.ajax({url:ajaxurl,type:"POST",data:{nonce:document.querySelector("#wpgb_fields_nonce").value,action:"wpgb_card",method:"get_settings",object:"settings",id:document.querySelector('[name="wpgb_id"]').value},error:function(e){WPGB_Popup_Message("unknown","error")},success:function(e){if(e.success&&e.content){L=e.content.fonts,P=e.content.content,N=e.content.settings,wpgb_builder_blocks=e.content.blocks,wpgb_builder_layout=e.content.layers;for(var t=[],n=(P.panels.blocks.fields.filter(function(e){return-1<["source","post_field","term_field","user_field","product_field"].indexOf(e.id)}).forEach(function(e){t[e.id]=e}),P.panels.general.fields.filter(function(e){return"available-blocks"===e.id})),i=(n=n[0]&&n[0].icons,wpgb_builder_blocks),o=[t.source.options,t.post_field.options,t.term_field.options,t.user_field.options,t.product_field.options],r=(R=o=o.reduce(function(e,t){for(var n in t)t.hasOwnProperty(n)&&(e[n]=t[n]);return e},{}),0),s=0;s<i.length;s++)if(i[s].blocks){var a,l,c,d,p={};for(a in wpgb_builder_blocks[s].blocks)wpgb_builder_blocks[s].blocks.hasOwnProperty(a)&&(l=wpgb_builder_blocks[s].blocks[a],c=l.settings.content,d=c.source,o[l.name]?(R[l.name]=o[l.name],D[l.name]=n[l.name],l.icon=l.name,l.name=o[l.name]):d&&c[d]&&!R[c[d]]?(R[c[d]]=l.name,D[c[d]]=l.icon):"custom_block"===d&&(l.block_name=a,l.settings.content.block_name=a,R[a]=l.name,D[a]=l.icon),p[r]=l,r++);wpgb_builder_blocks[s].blocks=p}new h,new f,b(),new v,new _,new w,(new g).init();var u=document.querySelector(".wpgb-preloader");u.classList.add("wpgb-loaded"),P.panels.general.fields.filter(function(e){return"available-blocks"===e.id}),setTimeout(function(){u.parentElement.removeChild(u)},600)}else WPGB_Popup_Message("unknown","error")}}),$(),window.addEventListener("resize",$,!0)}();